/* Created by Anjuta version 1.0.1 */
/*	This file will not be overwritten */

#include <mntent.h>
#include <fnmatch.h>
#include "../include/main.h"
#include "../include/gtkunipaned.h"
#include <gdk/gdkkeysyms.h>

// Variables
	GtkWidget *mainwindow, *maintoolbar, *commandline, *commandlineframe, *interminal;
	GtkWidget *dialog, *fromlabel, *tolabel, *progress, *progresscount, *progressbytes;
	gchar *progressbytestext=NULL,*progresstext=NULL;gfloat copycur,copysize;//gint copycur,copycount;
	GtkItemFactory *menuitemsfactory;
	GtkAccelGroup *accel_group;
	GtkWidget *leftwin, *leftstatusbar, *leftlist, *leftcombo, *leftcombolabel, *leftlabel;
	GtkWidget *rightwin, *rightstatusbar, *rightlist, *rightcombo, *rightcombolabel, *rightlabel;
	guint left_context_id, right_context_id, leftlabelid, rightlabelid, leftcomboid, rightcomboid, leftcombolabelid, rightcombolabelid;
	GArray *leftdir, *rightdir, *history[2];
	GList *leftcombolist = NULL, *rightcombolist = NULL;
	gchar *leftdirstr = NULL, *rightdirstr = NULL, *leftstatusstr=NULL, *rightstatusstr=NULL;
	gchar *titles[]={"Full Name","Unix Size","Unix Date","Type","Name","Ext","Size","Date","Attr"};
	GList *appsarr=getapps();
	GList *keysarr=getkeys(appsarr);
	GList *mimearr=getmimes(appsarr, keysarr);
	gint sortleft[6]={1,//sort type 0-unsorted, 1-name, 2-size, 3-time, 4-extension.
					TRUE,// Directory first
					TRUE,// Case sensitive
					TRUE,// Show hidden
					FALSE,// Show backup
					FALSE// Reverse order
					};
	gint sortright[6]={1,//sort type 0-unsorted, 1-name, 2-size, 3-time, 4-extension.
					TRUE,// Directory first
					TRUE,// Case sensitive
					TRUE,// Show hidden
					FALSE,// Show backup
					FALSE// Reverse order
					};
	
	GtkWidget *mainvbox,*mainpaned;
	GtkWidget *leftvbox, *lefthbox, *leftcdmain, *leftcdup;
	GtkWidget *rightvbox, *righthbox, *rightcdmain, *rightcdup;
	gint update = FALSE, toolbartype=1, showicons=1, selectdirs=0 , calcdirssize=1 ,
			sortdirsfull = FALSE, curfocus=0, curhistory[2]={0,0};
	gint all,messageboxinputattr=FALSE,abortcopy;
	gchar *str, *selection=g_strdup("*");
	gchar *configfilename=g_strconcat(getenv("HOME"),"/.mrcommander",NULL);
	gchar *editor=g_strdup("gedit"), *terminal=g_strdup("gnome-terminal -e");

// Functions
void attributes(){preview();}
void preview(){ messageboxerror("Coming soon!\nThis is only preview ...");}
void updatemenu();void maketoolbar();void makeunilist();void maketitles();
gchar * goleft (gchar *dir){return godir(dir, leftdir, leftlist, sortleft[3], sortleft[4], NULL, showicons);}
gchar * goright (gchar *dir){return godir(dir, rightdir, rightlist, sortright[3], sortright[4], NULL, showicons);}
gchar * goleftdef (gchar *dir, gchar *defdir){return godir(dir, leftdir, leftlist, sortleft[3], sortleft[4], defdir, showicons);}
gchar * gorightdef (gchar *dir, gchar *defdir){return godir(dir, rightdir, rightlist, sortright[3], sortright[4], defdir, showicons);}
void goleftdir (){leftdirstr=goleft((gchar *)gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(leftcombo)->entry)));mainrefresh();}
void gorightdir (){rightdirstr=goright((gchar *)gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(rightcombo)->entry)));mainrefresh();}
void goleftdirup (){leftdirstr=goleft(g_strconcat(leftdirstr,"..",NULL));mainrefresh();}
void gorightdirup (){rightdirstr=goright(g_strconcat(rightdirstr,"..",NULL));mainrefresh();}
void godirup(){if (curfocus==0) goleftdirup();else gorightdirup();}
void godirback(){godirup();};void gocurdir(gchar *);
void godirforward(){gchar *dir;
	if (curfocus==0){gtk_unilist_get_text(GTK_UNILIST(leftlist),GTK_UNILIST(leftlist)->focus_row,0,&dir);gocurdir(dir);}
	else {gtk_unilist_get_text(GTK_UNILIST(rightlist),GTK_UNILIST(rightlist)->focus_row,0,&dir);gocurdir(dir);}
}
int event_key_press(GtkWidget *list, GdkEventKey *event, gpointer data);
int event_button_press(GtkWidget *list, GdkEventButton *event, gpointer data);
int event_rightlistkeys(GtkWidget *list, GdkEventKey *event, gpointer data);
int commandline_lost_focus(GtkWidget *list, GdkEventKey *event, gpointer data);
gint listcompare (GtkUniList *list,gconstpointer ptr1,gconstpointer ptr2);
void about(){messageboxinfo("Mr Commander v0.1a-preview6\nhttp://mrcommander.sf.net/\nAuthor: Mr_Roberto <kompiuteriailt@yahoo.com>\nLithuania");}

int main( int   argc, char *argv[] ){
//	g_print("Count:%d:%d:%d\n",g_list_length(appsarr),g_list_length(keysarr),g_list_length(mimearr));
//	struct VFS_mime *data;
//	for (guint i=0;i<g_list_length(mimearr);i++){
//		data=(VFS_mime*)g_list_nth_data(mimearr,i);
//		g_print("%s:%s:%s\n",data->regex,data->icon,data->name);
//	}
	//GtkWidget *aligment = gtk_alignment_new(0,0.50,1,0);

	
	/* This is called in all GTK applications. Arguments are parsed
     * from the command line and are returned to the application. */
	gtk_init(&argc, &argv);
    
    /* create a new window */
    mainwindow = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	GdkPixbuf * mainicon = gdk_pixbuf_new_from_file("/usr/share/pixmaps/ooo_gulls.png",NULL);
	if (mainicon!=NULL)	gtk_window_set_icon(GTK_WINDOW(mainwindow),mainicon);
	else g_printerr("Icon not found, but nothing wrong...\n");
	g_signal_connect (GTK_OBJECT (mainwindow), "destroy",(GtkSignalFunc) destroy, NULL);
	mainvbox = gtk_vbox_new(FALSE, 0);
	menuitemsfactory = menu(mainwindow, mainvbox, accel_group);

	mainpaned = gtk_unipaned_new();
	GTK_PANED(mainpaned)->cursor_type = GDK_FLEUR;

	//main toolbar
	maketoolbar();
	//main left and right titles
	leftvbox = gtk_vbox_new(FALSE, 0);
	rightvbox = gtk_vbox_new(FALSE, 0);
	maketitles();
	
	//main left and right scrolled windows
	leftwin = gtk_scrolled_window_new (NULL, NULL);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (leftwin),GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	rightwin = gtk_scrolled_window_new (NULL, NULL);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (rightwin),GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	//left and right unilist
	makeunilist();
	//left and right statusbar
	leftstatusbar = gtk_statusbar_new();
	rightstatusbar = gtk_statusbar_new();
	
	//main window begin parameters

	gtk_window_set_title(GTK_WINDOW(mainwindow),"Mr Commander v0.1a - LGPL");
	gtk_window_set_default_size(GTK_WINDOW(mainwindow),600,450);
	
	
	leftdirstr = (gchar *)g_list_nth_data(leftcombolist,0);
	rightdirstr = (gchar *)g_list_nth_data(rightcombolist,0);
	leftdir = g_array_new(FALSE, FALSE, 0);rightdir = g_array_new(FALSE, FALSE, 0);
	history[0] = g_array_new(FALSE, FALSE, 0);history[1] = g_array_new(FALSE, FALSE, 0);
	leftlabel = gtk_statusbar_new();
	gtk_statusbar_set_has_resize_grip(GTK_STATUSBAR(leftlabel),FALSE);
	leftlabelid = gtk_statusbar_get_context_id( GTK_STATUSBAR(leftlabel), "Left" );

	rightlabel = gtk_statusbar_new();
	gtk_statusbar_set_has_resize_grip(GTK_STATUSBAR(rightlabel),FALSE);
	rightlabelid = gtk_statusbar_get_context_id( GTK_STATUSBAR(rightlabel), "Right" );

    /* Put the box into the main window. */
	gtk_container_add (GTK_CONTAINER (mainwindow), mainvbox);
	gtk_box_pack_start(GTK_BOX(mainvbox), mainpaned, TRUE, TRUE, 0);
	gtk_paned_pack1 (GTK_PANED(mainpaned), leftvbox, TRUE, TRUE);
	gtk_paned_pack2 (GTK_PANED(mainpaned), rightvbox, TRUE, TRUE);
//	verticalarrangment();
	gtk_box_pack_start(GTK_BOX(leftvbox), lefthbox, FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(lefthbox), leftcombo, FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(lefthbox), leftcombolabel, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(lefthbox), gtk_vseparator_new(), FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(lefthbox), leftcdmain, FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(lefthbox), gtk_vseparator_new(), FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(lefthbox), leftcdup, FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(leftvbox), leftlabel, FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(leftvbox), leftwin, TRUE, TRUE, 0);
	gtk_container_add(GTK_CONTAINER(leftwin), GTK_WIDGET(leftlist));
	gtk_box_pack_start(GTK_BOX(leftvbox), leftstatusbar, FALSE, TRUE, 0);
	
	gtk_box_pack_start(GTK_BOX(rightvbox), righthbox, FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(righthbox), rightcombo, FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(righthbox), rightcombolabel, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(righthbox), gtk_vseparator_new(), FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(righthbox), rightcdmain, FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(righthbox), gtk_vseparator_new(), FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(righthbox), rightcdup, FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(rightvbox), rightlabel, FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(rightvbox), rightwin, TRUE, TRUE, 0);
	gtk_container_add(GTK_CONTAINER(rightwin), GTK_WIDGET(rightlist));
	gtk_box_pack_start(GTK_BOX(rightvbox), rightstatusbar, FALSE, TRUE, 0);
	
	left_context_id = gtk_statusbar_get_context_id( GTK_STATUSBAR(leftstatusbar), "Left" );
	right_context_id = gtk_statusbar_get_context_id( GTK_STATUSBAR(rightstatusbar), "Right" );

	commandlineframe = gtk_frame_new("Command line");gtk_box_pack_start(GTK_BOX(mainvbox), commandlineframe, FALSE, TRUE, 0);
	GtkWidget *hbox2=gtk_hbox_new(FALSE,1);interminal = gtk_check_button_new_with_mnemonic("Run in _Terminal");
	commandline = gtk_entry_new();gtk_container_add(GTK_CONTAINER(commandlineframe),hbox2);
	gtk_box_pack_start(GTK_BOX(hbox2), commandline, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(hbox2), interminal, FALSE, TRUE, 0);
	gtk_signal_connect(GTK_OBJECT(commandline),"key-press-event",G_CALLBACK(commandline_lost_focus),NULL);
	gtk_signal_connect(GTK_OBJECT(interminal),"toggled",G_CALLBACK(gtk_unilist_set_focus),NULL);

	/* The final step is to display this newly created widget and the window */
	getsettings();
	//g_print("SIZE:%f\n",calcdirsize("/bin"));return (0);
	//g_print("icon:%s\n",geticon("i-directory.png"));
	gtk_widget_show_all(mainwindow);gorightdir();goleftdir();
    /* All GTK applications must have a gtk_main(). Control ends here
     * and waits for an event to occur (like a key press or
     * mouse event). */
	gtk_main ();
	
	return (0);
}
void updatestatusbar(){
	g_free(leftstatusstr);leftstatusstr=generatestatus(GTK_UNILIST(leftlist));
	gtk_statusbar_push( GTK_STATUSBAR(leftstatusbar), GPOINTER_TO_INT(left_context_id), leftstatusstr);
	g_free(rightstatusstr);rightstatusstr=generatestatus(GTK_UNILIST(rightlist));
	gtk_statusbar_push( GTK_STATUSBAR(rightstatusbar), GPOINTER_TO_INT(right_context_id), rightstatusstr);
}
void mainrefresh(){
	struct statfs fsd;
	gfloat free,total;
	gtk_statusbar_push( GTK_STATUSBAR(leftlabel), GPOINTER_TO_INT(leftlabelid), leftdirstr);
	gtk_statusbar_push( GTK_STATUSBAR(rightlabel), GPOINTER_TO_INT(rightlabelid), rightdirstr);
	updatecommandlineframe();
	if (statfs (leftdirstr, &fsd) >= 0) {free=(guint64)fsd.f_bsize*fsd.f_bavail;total=(guint64)fsd.f_bsize*fsd.f_blocks;
		gtk_statusbar_push( GTK_STATUSBAR(leftcombolabel), GPOINTER_TO_INT(leftcombolabelid), g_strdup_printf("free %s of %s",format_size(free),format_size(total)));
	} else gtk_statusbar_push( GTK_STATUSBAR(leftcombolabel), GPOINTER_TO_INT(leftcombolabelid), "");
	if (statfs (rightdirstr, &fsd) >= 0) {free=(guint64)fsd.f_bsize*fsd.f_bavail;total=(guint64)fsd.f_bsize*fsd.f_blocks;
		gtk_statusbar_push( GTK_STATUSBAR(rightcombolabel), GPOINTER_TO_INT(rightcombolabelid), g_strdup_printf("free %s of %s",format_size(free),format_size(total)));
	} else gtk_statusbar_push( GTK_STATUSBAR(rightcombolabel), GPOINTER_TO_INT(rightcombolabelid), "");
	updatestatusbar();
}


void destroy(){gtk_main_quit();}
void changeleft(){gtk_combo_popup_list(leftcombo);}
void changeright(){gtk_combo_popup_list(rightcombo);}
void gocurdir(gchar *dir){
	if (curfocus==0) leftdirstr=goleft(g_strconcat(leftdirstr,dir,NULL));
	else rightdirstr=goright(g_strconcat(rightdirstr,dir,NULL));
	mainrefresh();
}
int event_key_press(GtkWidget *list, GdkEventKey *event, gpointer data){
	gint i, pos;
	gchar *text[8], *title;
	static gchar *unselectlabel="Shrink selection", *selectlabel="Expand selection";
	updatecommandlineframe();
	
	if (event->keyval == GDK_plus || event->keyval == GDK_KP_Add ||
		event->keyval == GDK_minus || event->keyval == GDK_KP_Subtract){
		str=g_strdup(selection);
		if (event->keyval == GDK_plus || event->keyval == GDK_KP_Add) title=selectlabel;
		else title=unselectlabel;
	if (messageboxinput(title, "Specify pattern (filter):")){
	  if (strlen(str)!=0){g_free(selection);selection=g_strdup(str);
		gtk_unilist_freeze(GTK_UNILIST(list));
		for (i=0; i<GTK_UNILIST(list)->rows;i++){
			gtk_unilist_get_text(GTK_UNILIST(list),i,3,&text[3]);
			gtk_unilist_get_text(GTK_UNILIST(list),i,0,&text[0]);
			if (fnmatch(selection,text[0],FNM_FILE_NAME)==0)
				if (event->keyval == GDK_plus || event->keyval == GDK_KP_Add){
					if (text[3][0]!='d' || selectdirs) gtk_unilist_real_select_row(GTK_UNILIST(list),i);
				}else gtk_unilist_real_unselect_row(GTK_UNILIST(list),i);
		}
		gtk_unilist_thaw(GTK_UNILIST(list));
	}}g_free(str);return TRUE;}
	if (event->keyval == GDK_asterisk || event->keyval == GDK_KP_Multiply){
		gtk_unilist_freeze(GTK_UNILIST(list));
		for (i=0; i<GTK_UNILIST(list)->rows;i++) gtk_unilist_toggle_row(GTK_UNILIST(list),i);
		gtk_unilist_thaw(GTK_UNILIST(list));
		return TRUE;
	}
//	if (event->keyval == GDK_F3){g_print("123\n");
//		gtk_unilist_toggle_row(GTK_UNILIST(list),GTK_UNILIST(list)->focus_row);
//		gtk_signal_emit_by_name(GTK_OBJECT(list),"scroll_vertical", GTK_SCROLL_STEP_FORWARD, 0.0);
//		return TRUE;
//	}
	if (event->keyval == GDK_Insert){
		gtk_unilist_toggle_row(GTK_UNILIST(list),GTK_UNILIST(list)->focus_row);
		gtk_signal_emit_by_name(GTK_OBJECT(list),"scroll_vertical", GTK_SCROLL_STEP_FORWARD, 0.0);
		return TRUE;
	}
	if (event->keyval == GDK_KP_Enter || event->keyval == GDK_Return){
		gint row = GTK_UNILIST(list)->focus_row;
		gtk_unilist_get_text(GTK_UNILIST(list),row,0,&text[0]);
		gtk_unilist_get_text(GTK_UNILIST(list),row,3,&text[3]);
	  if (event->state&GDK_CONTROL_MASK || event->state&GDK_MOD1_MASK){
			pos=GTK_ENTRY(commandline)->current_pos;text[0]=escapefilename(text[0]);
			gtk_signal_emit_by_name(GTK_OBJECT(commandline),"insert-at-cursor",text[0],NULL);
			gtk_window_set_focus (GTK_WINDOW(mainwindow), commandline);
			gtk_entry_set_position(GTK_ENTRY(commandline),pos+strlen(text[0]));
			return TRUE;
	  }else{
		if (event->state&GDK_SHIFT_MASK){gchar *command = (gchar *)gtk_entry_get_text(GTK_ENTRY(commandline));
			if (strlen(command)>0){execute(command);gtk_entry_set_text(GTK_ENTRY(commandline),"");return TRUE;}
		}if (text[3][0]=='d'){ gocurdir(text[0]);
		} else {VFS_mime *mimedata=checkregex(text[0]);gchar *filename;
			if (mimedata!=NULL){//g_print("%s:%s\n",mimedata->name,mimedata->icon);
				if (mimedata->name!=NULL){
					gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(interminal),mimedata->terminal);
					filename=g_strdup_printf("%s %s",mimedata->name,escapefilename(text[0]));
					execute(filename);g_free(filename);return TRUE;
			}}
			filename=g_strdup_printf("./%s",escapefilename(text[0]));
			execute(filename);g_free(filename);
		}
		return TRUE;
	}}

	if (event->keyval == GDK_Tab){
		if (list==leftlist) gtk_window_set_focus (GTK_WINDOW(mainwindow), rightlist);
		if (list==rightlist) gtk_window_set_focus (GTK_WINDOW(mainwindow), leftlist);
		updatecommandlineframe();
		return TRUE;
	}
	gchar key[6];gunichar c=gdk_keyval_to_unicode(event->keyval);
	if (g_unichar_isalnum(c)||g_unichar_ispunct(c)){g_unichar_to_utf8(c,key);
		pos=GTK_ENTRY(commandline)->current_pos;
		gtk_signal_emit_by_name(GTK_OBJECT(commandline),"insert-at-cursor",key,NULL);
		gtk_window_set_focus (GTK_WINDOW(mainwindow), commandline);
		gtk_entry_set_position(GTK_ENTRY(commandline),pos+1);
		return TRUE;
	}
	return FALSE;
}
int event_button_press(GtkWidget *list, GdkEventButton *event, gpointer data){
	gchar *text[8];
	updatecommandlineframe();
	if (event->type == GDK_2BUTTON_PRESS){
		gint row = GTK_UNILIST(list)->focus_row;
		gtk_unilist_get_text(GTK_UNILIST(list),row,0,&text[0]);
		gtk_unilist_get_text(GTK_UNILIST(list),row,3,&text[3]);
		if (text[3][0]=='d'){gocurdir(text[0]);return TRUE;
		} else {VFS_mime *mimedata=checkregex(text[0]);gchar *filename;
			if (mimedata!=NULL){//g_print("%s:%s\n",mimedata->name,mimedata->icon);
				if (mimedata->name!=NULL){
					gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(interminal),mimedata->terminal);
					filename=g_strdup_printf("%s %s",mimedata->name,escapefilename(text[0]));
					execute(filename);g_free(filename);return TRUE;
			}}
			filename=g_strdup_printf("./%s",escapefilename(text[0]));
			execute(filename);g_free(filename);
		}
	}
	return FALSE;
}

gint listcompare (GtkUniList *list, const gconstpointer ptr1,gconstpointer ptr2){
	gchar 	*type1=NULL,*type2=NULL,
			*text1=NULL,*text2=NULL;
	gchar *search1,*search2;
	guint size1,size2;
	GtkUniListRow *row1 = (GtkUniListRow *) ptr1;
	GtkUniListRow *row2 = (GtkUniListRow *) ptr2;
	type1 = GTK_CELL_TEXT (row1->cell[3])->text;
	type2 = GTK_CELL_TEXT (row2->cell[3])->text;
	gint sortarr[6],i;
	if (GTK_WIDGET(list)==leftlist) for (i=0;i<6;i++) sortarr[i]=sortleft[i];
	else for (i=0;i<6;i++) sortarr[i]=sortright[i];
	
	if (sortarr[1]){ //check directory first
		if (type1[0]=='d') if (type2[0]!='d'){if (sortarr[5]) return 1;
														else return -1;}
		if (type2[0]=='d') if (type1[0]!='d'){if (sortarr[5]) return -1;
														else return 1;}
	}
	if (sortarr[0]==0) return 0; //unsorted
	if (type2[0]!='d' || sortdirsfull){
		if (sortarr[0]==3){
		size1 = atoi(GTK_CELL_TEXT (row1->cell[2])->text);
		size2 = atoi(GTK_CELL_TEXT (row2->cell[2])->text);
		if (size1!=size2){
			if (sortarr[5]){ if (size1>size2) return 1;else return -1;}
			else{ if (size1>size2) return -1;else return 1;}
	  }}
	  if (sortarr[0]==2){
		size1 = atoi(GTK_CELL_TEXT (row1->cell[1])->text);
		size2 = atoi(GTK_CELL_TEXT (row2->cell[1])->text);
		if (size1!=size2){
			if (sortarr[5]){ if (size1>size2) return 1;else return -1;}
			else{ if (size1>size2) return -1;else return 1;}
	}}}
	text1 = GTK_CELL_TEXT (row1->cell[0])->text;
	text2 = GTK_CELL_TEXT (row2->cell[0])->text;
	if (sortarr[0]==4){// sort by extension
		search1=strrchr(text1,'.');if (search1==text1) search1=NULL;
		search2=strrchr(text2,'.');if (search2==text2) search2=NULL;
		if (search1==NULL && search2!=NULL){if (sortarr[5]) return 1;
														else return -1;}
		if (search1!=NULL && search2==NULL){if (sortarr[5]) return -1;
														else return 1;}
		if (search1!=NULL && search2!=NULL){
			if (sortarr[2]){ if (sortarr[5]) return strcmp (search2, search1);
					  else return strcmp (search1, search2);}
			else{ if (sortarr[5])return strcoll (search2, search1);
			  else return strcoll (search1, search2);}
			}
	}
	if (sortarr[2]){ if (sortarr[5]) return strcmp (text2, text1);
					  else return strcmp (text1, text2);}
	else{ if (sortarr[5])return strcoll (text2, text1);
		  else return strcoll (text1, text2);}
}
void maketitles(){
	gchar *home=(gchar *)g_get_home_dir();
	if (home != NULL){
		leftcombolist = g_list_append(leftcombolist, home);
		rightcombolist = g_list_append(rightcombolist, home);
	}	
	gchar *dirparent = "/";
	leftcombolist = g_list_append(leftcombolist, dirparent);
	rightcombolist = g_list_append(rightcombolist, dirparent);
	struct mntent *mntdir;
	FILE * file = setmntent(_PATH_MOUNTED,"r");
	if (file != NULL){mntdir = getmntent(file);
		while (mntdir != NULL){
			if (strcmp(g_strndup(mntdir->mnt_dir,5),"/proc") && 
						strcmp(mntdir->mnt_dir,"/dev/pts") &&
						strcmp(mntdir->mnt_dir,dirparent) &&
						strcmp(mntdir->mnt_dir,home)){
				gchar *dir = g_strdup(mntdir->mnt_dir);
				leftcombolist = g_list_append(leftcombolist, dir);
				rightcombolist = g_list_append(rightcombolist, dir);
			}
			mntdir = getmntent(file);
		}
		endmntent(file);
	}
	
	lefthbox = gtk_hbox_new(FALSE, 0);
	leftcombo = gtk_combo_new();
	gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(leftcombo)->entry),FALSE);
	GTK_WIDGET_UNSET_FLAGS(GTK_COMBO(leftcombo)->entry,GTK_CAN_FOCUS);
	gtk_combo_set_popdown_strings(GTK_COMBO(leftcombo), leftcombolist);
	leftcombolabel = gtk_statusbar_new();
	gtk_statusbar_set_has_resize_grip(GTK_STATUSBAR(leftcombolabel),FALSE);
	leftcombolabelid = gtk_statusbar_get_context_id( GTK_STATUSBAR(leftcombolabel), "Left" );
//	gtk_misc_set_alignment(GTK_MISC(leftcombolabel),0,0.5);
	leftcdmain = gtk_button_new_with_label("/");
	leftcdup = gtk_button_new_with_label("..");
	GTK_WIDGET_UNSET_FLAGS(leftcdmain,GTK_CAN_FOCUS);
	GTK_WIDGET_UNSET_FLAGS(leftcdup,GTK_CAN_FOCUS);
	gtk_button_set_relief(GTK_BUTTON(leftcdmain), GTK_RELIEF_NONE);
	gtk_button_set_relief(GTK_BUTTON(leftcdup), GTK_RELIEF_NONE);
	leftcomboid=g_signal_connect (GTK_OBJECT (GTK_COMBO(leftcombo)->entry), "changed",(GtkSignalFunc) goleftdir, NULL );
//	g_signal_connect (GTK_OBJECT (leftcombo), "leave-notify-event",(GtkSignalFunc) goleftdir, NULL );
//	g_signal_connect (GTK_OBJECT (GTK_COMBO(leftcombo)->popwin), "leave-notify-event",(GtkSignalFunc) goleftdir, NULL );
	g_signal_connect (GTK_OBJECT (leftcdmain), "clicked",(GtkSignalFunc) goleftdir, NULL );
	g_signal_connect (GTK_OBJECT (leftcdup), "clicked",(GtkSignalFunc) goleftdirup, NULL );
	
	righthbox = gtk_hbox_new(FALSE, 0);
	rightcombo = gtk_combo_new();
	gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(rightcombo)->entry),FALSE);
	GTK_WIDGET_UNSET_FLAGS(GTK_COMBO(rightcombo)->entry,GTK_CAN_FOCUS);
	gtk_combo_set_popdown_strings(GTK_COMBO(rightcombo), rightcombolist);
	rightcombolabel = gtk_statusbar_new();
	gtk_statusbar_set_has_resize_grip(GTK_STATUSBAR(rightcombolabel),FALSE);
	rightcombolabelid = gtk_statusbar_get_context_id( GTK_STATUSBAR(rightcombolabel), "Right" );
//	gtk_misc_set_alignment(GTK_MISC(rightcombolabel),0,0.5);
	rightcdmain = gtk_button_new_with_label("/");
	rightcdup = gtk_button_new_with_label("..");
	GTK_WIDGET_UNSET_FLAGS(rightcdmain,GTK_CAN_FOCUS);
	GTK_WIDGET_UNSET_FLAGS(rightcdup,GTK_CAN_FOCUS);
	gtk_button_set_relief(GTK_BUTTON(rightcdmain), GTK_RELIEF_NONE);
	gtk_button_set_relief(GTK_BUTTON(rightcdup), GTK_RELIEF_NONE);
	rightcomboid=g_signal_connect (GTK_ENTRY (GTK_COMBO(rightcombo)->entry), "changed",(GtkSignalFunc) gorightdir, NULL );
//	g_signal_connect (GTK_OBJECT (GTK_COMBO(rightcombo)->popwin), "leave-notify-event",(GtkSignalFunc) gorightdir, NULL );
	g_signal_connect (GTK_OBJECT (rightcdmain), "clicked",(GtkSignalFunc) gorightdir, NULL );
	g_signal_connect (GTK_OBJECT (rightcdup), "clicked",(GtkSignalFunc) gorightdirup, NULL );

	//resize left and right combo
	GtkRequisition requisition;
	gtk_widget_size_request(leftcombo,&requisition);
	gtk_widget_set_usize(leftcombo,100,requisition.height);
	gtk_widget_set_usize(rightcombo,100,requisition.height);

}
void makeunilist(){
	
	leftlist = gtk_unilist_new_with_titles (9, titles);
	gtk_unilist_set_selection_mode(GTK_UNILIST(leftlist),GTK_SELECTION_MULTIPLE);
	gtk_unilist_column_titles_passive(GTK_UNILIST(leftlist));
	gtk_unilist_set_column_visibility(GTK_UNILIST(leftlist),0,FALSE);
	gtk_unilist_set_column_visibility(GTK_UNILIST(leftlist),1,FALSE);
	gtk_unilist_set_column_visibility(GTK_UNILIST(leftlist),2,FALSE);
	gtk_unilist_set_column_visibility(GTK_UNILIST(leftlist),3,FALSE);
	gtk_unilist_set_column_visibility(GTK_UNILIST(leftlist),5,FALSE);
//	gtk_unilist_set_column_visibility(GTK_UNILIST(leftlist),6,FALSE);
	gtk_unilist_set_compare_func(GTK_UNILIST (leftlist),listcompare);
//	gtk_unilist_set_auto_sort(GTK_UNILIST (leftlist),TRUE);
//	gtk_unilist_set_shadow_type (GTK_UNILIST (leftlist), GTK_SHADOW_OUT);
//	gtk_unilist_set_column_width (GTK_UNILIST (leftlist), 0, 150);
	gtk_unilist_set_column_auto_resize(GTK_UNILIST (leftlist), 4, TRUE);
	gtk_unilist_set_column_auto_resize(GTK_UNILIST (leftlist), 6, TRUE);
	gtk_unilist_set_column_auto_resize(GTK_UNILIST (leftlist), 7, TRUE);
	gtk_unilist_set_column_auto_resize(GTK_UNILIST (leftlist), 8, TRUE);
//	gtk_unilist_set_column_width (GTK_UNILIST (leftlist), 6, 30);
//	gtk_unilist_set_column_width (GTK_UNILIST (leftlist), 7, 80);
//	gtk_unilist_set_column_width (GTK_UNILIST (leftlist), 8, 80);
//	gtk_unilist_set_column_width (GTK_UNILIST (leftlist), 9, 60);
	gtk_unilist_set_button_actions(GTK_UNILIST (leftlist), 0, GTK_BUTTON_DRAGS);
	gtk_unilist_set_button_actions(GTK_UNILIST (leftlist), 2, GTK_BUTTON_SELECTS);
	g_signal_connect_after (GTK_UNILIST (leftlist), "selection_changed",(GtkSignalFunc) mainrefresh, NULL );
	g_signal_connect_after (GTK_OBJECT (leftlist), "key_press_event",(GtkSignalFunc) event_key_press, NULL );
	g_signal_connect_after (GTK_OBJECT (leftlist), "button_press_event",(GtkSignalFunc) event_button_press, NULL );


	rightlist = gtk_unilist_new_with_titles (9, titles);
	gtk_unilist_set_selection_mode(GTK_UNILIST(rightlist),GTK_SELECTION_MULTIPLE);
	gtk_unilist_set_column_visibility(GTK_UNILIST(rightlist),0,FALSE);
	gtk_unilist_set_column_visibility(GTK_UNILIST(rightlist),1,FALSE);
	gtk_unilist_set_column_visibility(GTK_UNILIST(rightlist),2,FALSE);
	gtk_unilist_set_column_visibility(GTK_UNILIST(rightlist),3,FALSE);
	gtk_unilist_set_column_visibility(GTK_UNILIST(rightlist),5,FALSE);
//	gtk_unilist_set_column_visibility(GTK_UNILIST(rightlist),6,FALSE);
	gtk_unilist_set_compare_func(GTK_UNILIST (rightlist),listcompare);
	gtk_unilist_column_titles_passive(GTK_UNILIST(rightlist));
	gtk_unilist_set_column_justification(GTK_UNILIST (rightlist), 5, GTK_JUSTIFY_RIGHT);
	gtk_unilist_set_column_auto_resize(GTK_UNILIST (rightlist), 4, TRUE);
	gtk_unilist_set_column_auto_resize(GTK_UNILIST (rightlist), 6, TRUE);
	gtk_unilist_set_column_auto_resize(GTK_UNILIST (rightlist), 7, TRUE);
	gtk_unilist_set_column_auto_resize(GTK_UNILIST (rightlist), 8, TRUE);
//	gtk_unilist_set_column_width (GTK_UNILIST (rightlist), 0, 150);
//	gtk_unilist_set_column_width (GTK_UNILIST (rightlist), 6, 30);
//	gtk_unilist_set_column_width (GTK_UNILIST (rightlist), 7, 80);
//	gtk_unilist_set_column_width (GTK_UNILIST (rightlist), 8, 80);
//	gtk_unilist_set_column_width (GTK_UNILIST (rightlist), 9, 60);
	gtk_unilist_set_button_actions(GTK_UNILIST (rightlist), 0, GTK_BUTTON_DRAGS);
	gtk_unilist_set_button_actions(GTK_UNILIST (rightlist), 2, GTK_BUTTON_SELECTS);
//	g_signal_connect_after (GTK_OBJECT (rightlist), "key_press_event",(GtkSignalFunc) event_rightlistkeys, NULL );
	g_signal_connect_after (GTK_UNILIST (rightlist), "selection_changed",(GtkSignalFunc) mainrefresh, NULL );
	g_signal_connect_after (GTK_OBJECT (rightlist), "key_press_event",(GtkSignalFunc) event_key_press, NULL );
	g_signal_connect_after (GTK_OBJECT (rightlist), "button_press_event",(GtkSignalFunc) event_button_press, NULL );
	

}
void rereadsource(){
	gchar *row1,*row2;
	gtk_unilist_get_text(GTK_UNILIST(leftlist),GTK_UNILIST(leftlist)->focus_row,0,&row1);
	gtk_unilist_get_text(GTK_UNILIST(rightlist),GTK_UNILIST(rightlist)->focus_row,0,&row2);
	if (gtk_widget_is_focus(leftlist)) goleftdef(leftdirstr,row1);
	if (gtk_widget_is_focus(rightlist)) gorightdef(rightdirstr,row2);
	mainrefresh();
}
void rereadsourceall(){gint i=curfocus;
	if (gtk_widget_is_focus(leftlist)){gtk_window_set_focus(GTK_WINDOW(mainwindow),rightlist);rereadsource();}
	if (gtk_widget_is_focus(rightlist)){gtk_window_set_focus(GTK_WINDOW(mainwindow),leftlist);rereadsource();}
	curfocus=i;gtk_unilist_set_focus();rereadsource();
}
void targetsource(){
	if (gtk_widget_is_focus(leftlist)){
		rightdirstr=g_strdup(leftdirstr);goright(rightdirstr);
		gtk_window_set_focus(GTK_WINDOW(mainwindow),leftlist);
	}
	if (gtk_widget_is_focus(rightlist)){
		leftdirstr=g_strdup(rightdirstr);goleft(leftdirstr);
		gtk_window_set_focus(GTK_WINDOW(mainwindow),rightlist);
	}
	mainrefresh();
}
void gohome(){
	if (gtk_widget_is_focus(leftlist)){leftdirstr=g_strconcat(g_get_home_dir(),"/",NULL);goleft(rightdirstr);}
	if (gtk_widget_is_focus(rightlist)){rightdirstr=g_strconcat(g_get_home_dir(),"/",NULL);goright(rightdirstr);}
	mainrefresh();
}
void sourcetarget(){
	gchar *str=rightdirstr;rightdirstr=leftdirstr;leftdirstr=str;
	str=strdup(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(rightcombo)->entry)));
	gtk_signal_handler_block(GTK_OBJECT (GTK_COMBO(leftcombo)->entry),leftcomboid);
	gtk_signal_handler_block(GTK_OBJECT (GTK_COMBO(rightcombo)->entry),rightcomboid);
	gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(rightcombo)->entry),gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(leftcombo)->entry)));
	gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(leftcombo)->entry),str);
	for (gint i=0;i<4;i++){gint temp=sortright[i];sortright[i]=sortleft[i];sortleft[i]=temp;}
	gchar *row1,*row2;
	gtk_unilist_get_text(GTK_UNILIST(leftlist),GTK_UNILIST(leftlist)->focus_row,0,&row1);
	gtk_unilist_get_text(GTK_UNILIST(rightlist),GTK_UNILIST(rightlist)->focus_row,0,&row2);
	gchar *file1=g_strdup(row1), *file2=g_strdup(row2);
	if (gtk_widget_is_focus(leftlist)){goleftdef(leftdirstr,file2);gorightdef(rightdirstr,file1);}
	else {gorightdef(rightdirstr,file1);goleftdef(leftdirstr,file2);}
	gtk_signal_handler_unblock(GTK_OBJECT (GTK_COMBO(leftcombo)->entry),leftcomboid);
	gtk_signal_handler_unblock(GTK_OBJECT (GTK_COMBO(rightcombo)->entry),rightcomboid);
	mainrefresh();
	
}
void verticalarrangment(){
	if (gtk_check_menu_item_get_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Vertical Arrangment")))
		GTK_PANED(mainpaned)->orientation = GTK_ORIENTATION_HORIZONTAL;
	else GTK_PANED(mainpaned)->orientation = GTK_ORIENTATION_VERTICAL;
//	GTK_PANED(mainpaned)->cursor_type = GDK_SB_V_DOUBLE_ARROW;
	gtk_widget_hide(mainpaned);gtk_widget_show(mainpaned);
}
void updatemenu(){update=TRUE;
	switch (sortleft[0]){
		case 0: gtk_check_menu_item_set_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Left Arrange Items/Unsorted"),TRUE);break;
		case 1: gtk_check_menu_item_set_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Left Arrange Items/By Name"),TRUE);break;
		case 2: gtk_check_menu_item_set_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Left Arrange Items/By Size"),TRUE);break;
		case 3: gtk_check_menu_item_set_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Left Arrange Items/By Time"),TRUE);break;
		case 4: gtk_check_menu_item_set_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Left Arrange Items/By Extension"),TRUE);break;
	}
	gtk_check_menu_item_set_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Left Arrange Items/Directory first"),sortleft[1]);
	gtk_check_menu_item_set_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Left Arrange Items/Case Sensitive"),sortleft[2]);
	gtk_check_menu_item_set_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Left Arrange Items/Show Hidden"),sortleft[3]);
	gtk_check_menu_item_set_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Left Arrange Items/Show Backup"),sortleft[4]);
	gtk_check_menu_item_set_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Left Arrange Items/Reversed Order"),sortleft[5]);
	switch (sortright[0]){
		case 0: gtk_check_menu_item_set_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Right Arrange Items/Unsorted"),TRUE);break;
		case 1: gtk_check_menu_item_set_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Right Arrange Items/By Name"),TRUE);break;
		case 2: gtk_check_menu_item_set_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Right Arrange Items/By Size"),TRUE);break;
		case 3: gtk_check_menu_item_set_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Right Arrange Items/By Time"),TRUE);break;
		case 4: gtk_check_menu_item_set_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Right Arrange Items/By Extension"),TRUE);break;
	}
	gtk_check_menu_item_set_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Right Arrange Items/Directory first"),sortright[1]);
	gtk_check_menu_item_set_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Right Arrange Items/Case Sensitive"),sortright[2]);
	gtk_check_menu_item_set_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Right Arrange Items/Show Hidden"),sortright[3]);
	gtk_check_menu_item_set_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Right Arrange Items/Show Backup"),sortright[4]);
	gtk_check_menu_item_set_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Right Arrange Items/Reversed Order"),sortright[5]);
	switch (toolbartype){
		case 0: gtk_check_menu_item_set_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Toolbar/Show Icons and Text"),TRUE);break;
		case 1: gtk_check_menu_item_set_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Toolbar/Show Icons only"),TRUE);break;
		case 2: gtk_check_menu_item_set_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Toolbar/Show Text only"),TRUE);break;
		case 3: gtk_check_menu_item_set_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Toolbar/Hide Toolbar"),TRUE);break;
	}
	update=FALSE;changetoolbar();
}
void arrangeleft(){ if (update) return;
	if (gtk_check_menu_item_get_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Left Arrange Items/Unsorted")))sortleft[0]=0;
	if (gtk_check_menu_item_get_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Left Arrange Items/By Name")))sortleft[0]=1;
	if (gtk_check_menu_item_get_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Left Arrange Items/By Size")))sortleft[0]=2;
	if (gtk_check_menu_item_get_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Left Arrange Items/By Time")))sortleft[0]=3;
	if (gtk_check_menu_item_get_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Left Arrange Items/By Extension")))sortleft[0]=4;
	sortleft[1]=gtk_check_menu_item_get_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Left Arrange Items/Directory first"));
	sortleft[2]=gtk_check_menu_item_get_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Left Arrange Items/Case Sensitive"));
	sortleft[3]=gtk_check_menu_item_get_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Left Arrange Items/Show Hidden"));
	sortleft[4]=gtk_check_menu_item_get_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Left Arrange Items/Show Backup"));
	sortleft[5]=gtk_check_menu_item_get_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Left Arrange Items/Reversed Order"));
	gchar *row1;
	gtk_unilist_get_text(GTK_UNILIST(leftlist),GTK_UNILIST(leftlist)->focus_row,0,&row1);
	goleftdef(leftdirstr,row1);}
void arrangeright(){ if (update) return;
	if(gtk_check_menu_item_get_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Right Arrange Items/Unsorted")))sortright[0]=0;
	if(gtk_check_menu_item_get_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Right Arrange Items/By Name")))sortright[0]=1;
	if(gtk_check_menu_item_get_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Right Arrange Items/By Size")))sortright[0]=2;
	if(gtk_check_menu_item_get_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Right Arrange Items/By Time")))sortright[0]=3;
	if(gtk_check_menu_item_get_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Right Arrange Items/By Extension")))sortright[0]=4;
	sortright[1]=gtk_check_menu_item_get_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Right Arrange Items/Directory first"));
	sortright[2]=gtk_check_menu_item_get_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Right Arrange Items/Case Sensitive"));
	sortright[3]=gtk_check_menu_item_get_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Right Arrange Items/Show Hidden"));
	sortright[4]=gtk_check_menu_item_get_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Right Arrange Items/Show Backup"));
	sortright[5]=gtk_check_menu_item_get_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Right Arrange Items/Reversed Order"));
	gchar *row2;
	gtk_unilist_get_text(GTK_UNILIST(rightlist),GTK_UNILIST(rightlist)->focus_row,0,&row2);
	gorightdef(rightdirstr,row2);}
void maketoolbar(){
	maintoolbar = gtk_toolbar_new();
	gtk_toolbar_insert_stock(GTK_TOOLBAR(maintoolbar),GTK_STOCK_GO_BACK, "Go Back",NULL,godirback,NULL, -1);
	gtk_toolbar_insert_stock(GTK_TOOLBAR(maintoolbar),GTK_STOCK_GO_FORWARD, "Go Forward",NULL,godirforward,NULL, -1);
	gtk_toolbar_insert_stock(GTK_TOOLBAR(maintoolbar),GTK_STOCK_GO_UP, "Go Up",NULL,godirup,NULL, -1);
	gtk_toolbar_insert_stock(GTK_TOOLBAR(maintoolbar),GTK_STOCK_REFRESH, "Reread Source",NULL,rereadsource,NULL, -1);
	gtk_toolbar_append_space(GTK_TOOLBAR(maintoolbar));
	gtk_toolbar_insert_stock(GTK_TOOLBAR(maintoolbar),GTK_STOCK_HOME, "Go Home",NULL,gohome,NULL, -1);
	gtk_toolbar_append_space(GTK_TOOLBAR(maintoolbar));
	gtk_toolbar_insert_stock(GTK_TOOLBAR(maintoolbar),GTK_STOCK_INDEX, "FTP List",NULL,preview,NULL, -1);
	gtk_toolbar_insert_stock(GTK_TOOLBAR(maintoolbar),GTK_STOCK_JUMP_TO, "FTP Connect",NULL,ftpconnect,NULL, -1);
	gtk_toolbar_append_space(GTK_TOOLBAR(maintoolbar));
	gtk_toolbar_insert_stock(GTK_TOOLBAR(maintoolbar),GTK_STOCK_SAVE, "Save Settings",NULL,savesettings,NULL, -1);
	gtk_box_pack_start(GTK_BOX(mainvbox), maintoolbar, FALSE, TRUE, 0);
}
void changetoolbar(){ if (update) return;
	if(gtk_check_menu_item_get_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Toolbar/Show Icons and Text")))toolbartype=0;
	if(gtk_check_menu_item_get_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Toolbar/Show Icons only")))toolbartype=1;
	if(gtk_check_menu_item_get_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Toolbar/Show Text only")))toolbartype=2;
	if(gtk_check_menu_item_get_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Toolbar/Hide Toolbar")))toolbartype=3;
	if (toolbartype==3) gtk_widget_hide(maintoolbar);
	else{switch (toolbartype){
			case 0: gtk_toolbar_set_style(GTK_TOOLBAR(maintoolbar),GTK_TOOLBAR_BOTH);break;
			case 1: gtk_toolbar_set_style(GTK_TOOLBAR(maintoolbar),GTK_TOOLBAR_ICONS);break;
			case 2: gtk_toolbar_set_style(GTK_TOOLBAR(maintoolbar),GTK_TOOLBAR_TEXT);break;
		}gtk_widget_show(maintoolbar);}
}
void messageboxinfo(gchar* message){
	GtkWidget *dialog = gtk_message_dialog_new (GTK_WINDOW(mainwindow), GTK_DIALOG_DESTROY_WITH_PARENT,GTK_MESSAGE_INFO, GTK_BUTTONS_CLOSE, message);
	gtk_dialog_run(GTK_DIALOG(dialog));	gtk_widget_destroy(dialog);
}
void messageboxerror(gchar* message){
	GtkWidget *dialog = gtk_message_dialog_new (GTK_WINDOW(mainwindow), GTK_DIALOG_DESTROY_WITH_PARENT,GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, message);
	gtk_dialog_run(GTK_DIALOG(dialog));	gtk_widget_destroy(dialog);
}
gint messageboxyesno(gchar* message){
	GtkWidget *dialog = gtk_message_dialog_new (GTK_WINDOW(mainwindow), GTK_DIALOG_DESTROY_WITH_PARENT,GTK_MESSAGE_QUESTION, GTK_BUTTONS_YES_NO, message);
	if (gtk_dialog_run(GTK_DIALOG(dialog))==GTK_RESPONSE_YES){
		gtk_widget_destroy(dialog);
		return TRUE;
	}
	gtk_widget_destroy(dialog);
	return FALSE;
}
gint messageboxinput(gchar* title, gchar *label){
	GtkWidget *attr,*dialog = gtk_dialog_new_with_buttons (title,GTK_WINDOW(mainwindow), GTK_DIALOG_DESTROY_WITH_PARENT,GTK_STOCK_CANCEL,GTK_RESPONSE_REJECT,GTK_STOCK_OK,GTK_RESPONSE_ACCEPT,NULL);
	gtk_dialog_set_default_response(GTK_DIALOG(dialog),GTK_RESPONSE_ACCEPT);
	GtkWidget *gtkframe = gtk_frame_new(label);
	gtk_frame_set_label_align(GTK_FRAME(gtkframe),0.05,0.5);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), gtkframe, FALSE, TRUE, 0);
	if (messageboxinputattr==TRUE){
		attr= gtk_check_button_new_with_mnemonic("Preserve _Attributes");
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(attr),TRUE);
		gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), attr, FALSE, TRUE, 0);
	}
	GtkWidget *entry = gtk_entry_new();if (str!=NULL) gtk_entry_set_text(GTK_ENTRY(entry),str);
	gtk_entry_set_activates_default(GTK_ENTRY(entry),TRUE);
	gtk_container_add(GTK_CONTAINER(gtkframe),entry);
	gtk_window_set_focus(GTK_WINDOW(dialog),entry);
	gtk_widget_show_all(dialog);
	if (gtk_dialog_run(GTK_DIALOG(dialog))==GTK_RESPONSE_ACCEPT){
		if (messageboxinputattr==TRUE) 
			if (!gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(attr))) messageboxinputattr=FALSE;
		g_free(str);str=g_strdup(gtk_entry_get_text(GTK_ENTRY(entry)));
		gtk_widget_destroy(dialog);
		return TRUE;
	}
	messageboxinputattr=FALSE;
	gtk_widget_destroy(dialog);
	return FALSE;
}
void editsettings(){
	GError *error = NULL;
	FILE *file = fopen( configfilename, "r");
	if (file==NULL) messageboxerror("Settings file not found !!!");
	else {fclose(file);
		if (!g_spawn_command_line_async(g_strdup_printf("%s %s",editor,configfilename),&error))
			messageboxerror(error->message);
}}
void savesettings(){
	gint width, height, x,y;
	FILE *file = fopen( configfilename, "w");
  if (file!=NULL){
	gtk_window_get_size(GTK_WINDOW(mainwindow),&width,&height);
	gtk_window_get_position(GTK_WINDOW(mainwindow),&x,&y);
	fprintf(file,"[Mr Commander]\n");
	fprintf(file,"EditorProgram=%s\n",editor);
	fprintf(file,"TerminalProgram=%s\n",terminal);
	fprintf(file,"TopLeftX=%d\n",x);
	fprintf(file,"TopLeftY=%d\n",y);
	fprintf(file,"Width=%d\n",width);
	fprintf(file,"Height=%d\n",height);
	fprintf(file,"\n[Left panel]\n");
	fprintf(file,"LeftSortmode=%d //0-unsorted,1-name,2-size,3-time..\n",sortleft[0]);
	fprintf(file,"LeftDirfirst=%d #0-FALSE,1-TRUE\n",sortleft[1]);
	fprintf(file,"LeftCaseSens=%d\n",sortleft[2]);
	fprintf(file,"LeftShowHidden=%d\n",sortleft[3]);
	fprintf(file,"LeftShowBackup=%d\n",sortleft[4]);
	fprintf(file,"LeftReverseOrder=%d\n",sortleft[5]);
	fprintf(file,"[Right panel]\n");
	fprintf(file,"RightSortmode=%d //0-unsorted,1-name,2-size,3-time..\n",sortright[0]);
	fprintf(file,"RightDirfirst=%d #0-FALSE,1-TRUE\n",sortright[1]);
	fprintf(file,"RightCaseSens=%d\n",sortright[2]);
	fprintf(file,"RightShowHidden=%d\n",sortright[3]);
	fprintf(file,"RightShowBackup=%d\n",sortright[4]);
	fprintf(file,"RightReverseOrder=%d\n",sortright[5]);
	fprintf(file,"\n[Others]\n");
	fprintf(file,"VerticalArrangment=%d\n",gtk_check_menu_item_get_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Vertical Arrangment")));
	fprintf(file,"ToolBar=%d //0=Both, 1=Icons, 2=Text, 3=Hidden\n",toolbartype);
	fprintf(file,"ShowIcons=%d //0=VFS, 1=Standart, 2=None\n",showicons);
	fprintf(file,"FullSortDirs=%d\n",sortdirsfull);
	fprintf(file,"SelectDirs=%d\n",selectdirs);
	fprintf(file,"CalcDirsSize=%d\n",calcdirssize);
	fclose(file);messageboxinfo("Settings saved.");
  } else messageboxerror("Settings write error.");
}
#define LINE_LENGTH 80
void getsettings(){
	gchar line[LINE_LENGTH];
	gchar *found;gint width, height=0, value=0, x=-1, y=-1;
	FILE *file = fopen( configfilename, "r");
	if (file!=NULL){
	  while (fgets(line,LINE_LENGTH,file)!=NULL){
		if (strchr(line,'[')==NULL){strstr(line,"\n")[0]=0;
			found = strstr(line,"//");if (found!=NULL) found[0] = 0;
			found = strchr(line,'#');if (found!=NULL) found[0] = 0;
			found = strchr(line,'=');
		  if (found != NULL){found[0]=0;found++;value=atoi(found);
				if (strcasecmp("TerminalProgram",line)==0){g_free(terminal);terminal=g_strdup(found);}
				if (strcasecmp("EditorProgram",line)==0){g_free(editor);editor=strdup(found);}
				if (strcasecmp("Width",line)==0)width=value;if (strcasecmp("Height",line)==0)height=value;
				if (strcasecmp("TopLeftX",line)==0)x=value;if (strcasecmp("TopLeftY",line)==0)y=value;
				if (strcasecmp("LeftSortmode",line)==0)sortleft[0]=value;
				if (strcasecmp("LeftDirfirst",line)==0)sortleft[1]=value;
				if (strcasecmp("LeftCaseSens",line)==0)sortleft[2]=value;
				if (strcasecmp("LeftShowHidden",line)==0)sortleft[3]=value;
				if (strcasecmp("LeftShowBackup",line)==0)sortleft[4]=value;
				if (strcasecmp("LeftReverseOrder",line)==0)sortleft[5]=value;
				if (strcasecmp("RightSortmode",line)==0)sortright[0]=value;
				if (strcasecmp("RightDirfirst",line)==0)sortright[1]=value;
				if (strcasecmp("RightCaseSens",line)==0)sortright[2]=value;
				if (strcasecmp("RightShowHidden",line)==0)sortright[3]=value;
				if (strcasecmp("RightShowBackup",line)==0)sortright[4]=value;
				if (strcasecmp("RightReverseOrder",line)==0)sortright[5]=value;
				if (strcasecmp("ToolBar",line)==0)toolbartype=value;
				if (strcasecmp("ShowIcons",line)==0)showicons=value;
				if (strcasecmp("FullSortDirs",line)==0)sortdirsfull=value;
				if (strcasecmp("SelectDirs",line)==0)selectdirs=value;
				if (strcasecmp("CalcDirsSize",line)==0)calcdirssize=value;
				if (strcasecmp("VerticalArrangment",line)==0)gtk_check_menu_item_set_active((GtkCheckMenuItem *) gtk_item_factory_get_widget(menuitemsfactory,"/Show/Vertical Arrangment"),value);
		  }
		} //g_print("%s\n%s\n",terminal,editor);
	  }fclose(file);updatemenu();changetoolbar();rereadsourceall();
	  if (width!=0 && height!=0) gtk_window_resize(GTK_WINDOW(mainwindow),width,height);
	  if (x>=0 && y>=0) gtk_window_move(GTK_WINDOW(mainwindow),x,y);
	} else g_printerr("Settings file not found !!!\nLoading default...\n");
}
void makedir(){str=NULL;
	if (messageboxinput("Create Directory", "Enter directory name:")){
		if (strlen(str)>0){
			if (0==mkdir(str,S_IRWXU|S_IRWXG|S_IRWXO)){
				if (gtk_widget_is_focus(leftlist)){
					gtk_window_set_focus (GTK_WINDOW(mainwindow), rightlist);
					rereadsource();goleftdef(leftdirstr,str);
				}
				if (gtk_widget_is_focus(rightlist)){
					gtk_window_set_focus (GTK_WINDOW(mainwindow), leftlist);
					rereadsource();gorightdef(rightdirstr,str);
				}
			}else messageboxerror(strerror(errno));
	}}
}
void volumelabel(){str=g_strdup("Demo label");
	if (messageboxinput("Change Label", "New volume label:")){
		preview();
	}
}
gchar *generatestatus (GtkUniList *list){
	gchar *text[8];
	gchar *result=NULL;
//	g_print("2\n");
	gint files=0, filesselected=0;
	gfloat filessize=0, filesselectedsize=0;
	
	for (gint row=0; row<list->rows;row++){
		gtk_unilist_get_text(list,row,1,&text[1]);
		gtk_unilist_get_text(list,row,3,&text[3]);
		gtk_unilist_get_text(list,row,6,&text[6]);
		if (text[6][0]!='<')filessize+=atoi(text[1]);
		if (gtk_unilist_row_is_selected(list,row)){
			if (text[3][0]!='d')filesselected++;
			if (text[6][0]!='<')filesselectedsize+=atoi(text[1]);
		}
		if (text[3][0]!='d')files++;
	} 
	return g_strdup_printf("%s/%s in %d/%d files", 
		format_size(filesselectedsize), format_size(filessize), filesselected, files);
}
void options(){
	gint i;
	GtkWidget *gtkframe,*vbox,*vbox2;
	GtkWidget *dialog = gtk_dialog_new_with_buttons ("Preferences",GTK_WINDOW(mainwindow), GTK_DIALOG_DESTROY_WITH_PARENT,GTK_STOCK_CANCEL,GTK_RESPONSE_REJECT,GTK_STOCK_OK,GTK_RESPONSE_ACCEPT,NULL);
	gtk_dialog_set_default_response(GTK_DIALOG(dialog),GTK_RESPONSE_ACCEPT);
	GtkWidget *gtknotebook = gtk_notebook_new();
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), gtknotebook, FALSE, TRUE, 0);
//	vbox = gtk_vbox_new(FALSE,0);gtkframe = gtk_frame_new("Screen Layout");gtk_box_pack_start(GTK_BOX(vbox), gtkframe, FALSE, TRUE, 0);
//	gtk_notebook_append_page(GTK_NOTEBOOK(gtknotebook),vbox,gtk_label_new_with_mnemonic("_Layout"));

	vbox = gtk_vbox_new(FALSE,0);
	GtkWidget *calcdirsize=gtk_check_button_new_with_mnemonic("Calculate <DIR> size (F3,Space)");
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(calcdirsize),calcdirssize);
	gtk_box_pack_start(GTK_BOX(vbox), calcdirsize, FALSE, TRUE, 0);
	GtkWidget *sortdirs=gtk_check_button_new_with_mnemonic("Full sort <DIR> (for sort by name, size)");
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(sortdirs),sortdirsfull);
	gtk_box_pack_start(GTK_BOX(vbox), sortdirs, FALSE, TRUE, 0);
	gtk_notebook_append_page(GTK_NOTEBOOK(gtknotebook),vbox,gtk_label_new_with_mnemonic("_Operation"));
	GtkWidget *selection[2]; vbox2 = gtk_vbox_new(FALSE,0);
	gtkframe = gtk_frame_new("Selection (with Gray+)");gtk_box_pack_start(GTK_BOX(vbox), gtkframe, FALSE, TRUE, 0);
	selection[0] = gtk_radio_button_new_with_label(NULL,"Select files only");
	selection[1] = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(selection[0]),"Also select directories");
	gtk_container_add(GTK_CONTAINER(gtkframe),vbox2);
	gtk_box_pack_start(GTK_BOX(vbox2), selection[0], FALSE, TRUE, 0);gtk_box_pack_start(GTK_BOX(vbox2), selection[1], FALSE, TRUE, 0);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(selection[selectdirs]),TRUE);
	GtkWidget *term = gtk_entry_new();if (terminal!=NULL) gtk_entry_set_text(GTK_ENTRY(term),terminal);
	gtkframe = gtk_frame_new("X Terminal program:");gtk_box_pack_start(GTK_BOX(vbox), gtkframe, TRUE, TRUE, 0);	selection[0] = gtk_radio_button_new_with_label(NULL,"Select files only");
	gtk_container_add(GTK_CONTAINER(gtkframe),term);gtk_entry_set_activates_default(GTK_ENTRY(term),TRUE);

	vbox = gtk_vbox_new(FALSE,0);gtkframe = gtk_frame_new("Show Icons to the left of the filename");gtk_box_pack_start(GTK_BOX(vbox), gtkframe, FALSE, TRUE, 0);
	gtk_notebook_append_page(GTK_NOTEBOOK(gtknotebook),vbox,gtk_label_new_with_mnemonic("_Screen"));
	GtkWidget *showicon[3]; vbox2 = gtk_vbox_new(FALSE,0);
	showicon[0] = gtk_radio_button_new_with_label(NULL,"All associated icons from Gnome VFS (slowest)");
	showicon[1] = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(showicon[0]),"Only standart icons");
	showicon[2] = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(showicon[0]),"None (fastest)");
	gtk_container_add(GTK_CONTAINER(gtkframe),vbox2);
	gtk_box_pack_start(GTK_BOX(vbox2), showicon[0], FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(vbox2), showicon[1], FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(vbox2), showicon[2], FALSE, TRUE, 0);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(showicon[showicons]),TRUE);
	
	vbox = gtk_vbox_new(FALSE,0);gtkframe = gtk_frame_new("Editor program (F4):");gtk_box_pack_start(GTK_BOX(vbox), gtkframe, FALSE, TRUE, 0);
	gtk_notebook_append_page(GTK_NOTEBOOK(gtknotebook),vbox,gtk_label_new_with_mnemonic("_Edit/View"));
	GtkWidget *edit = gtk_entry_new();if (editor!=NULL) gtk_entry_set_text(GTK_ENTRY(edit),editor);
	gtk_container_add(GTK_CONTAINER(gtkframe),edit);gtk_entry_set_activates_default(GTK_ENTRY(edit),TRUE);


	gtk_widget_show_all(dialog);
	if (gtk_dialog_run(GTK_DIALOG(dialog))==GTK_RESPONSE_ACCEPT){
		g_free(editor);editor=g_strdup(gtk_entry_get_text(GTK_ENTRY(edit)));
		g_free(terminal);terminal=g_strdup(gtk_entry_get_text(GTK_ENTRY(term)));
		for (i=0;i<2;i++) if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(selection[i]))) selectdirs=i;
		for (i=0;i<3;i++) if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(showicon[i]))) showicons=i;
		if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(sortdirs))) sortdirsfull=TRUE;else sortdirsfull=FALSE;
		if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(calcdirsize))) calcdirssize=TRUE;else calcdirssize=FALSE;
		rereadsourceall();
	}
	gtk_widget_destroy(dialog);
}

void view(){
	GError *error = NULL;
	gchar *text[8];
	GtkUniList *list=NULL;
	if (gtk_widget_is_focus(leftlist)) list = GTK_UNILIST(leftlist);
	if (gtk_widget_is_focus(rightlist)) list = GTK_UNILIST(rightlist);
	if (list != NULL){
		gtk_unilist_get_text(list,list->focus_row,0,&text[0]);
		gtk_unilist_get_text(list,list->focus_row,3,&text[3]);
		gtk_unilist_get_text(list,list->focus_row,6,&text[6]);
//		g_print("%s\n",gtk_entry_get_text(GTK_ENTRY(commandline)));
		chdir (gtk_frame_get_label(GTK_FRAME(commandlineframe)));
		if (text[3][0]=='d' ){
			if (strcmp(text[0],"..")!=0){
			text[1]=g_strdup_printf("%0.0f",calcdirsize(text[0]));
			gtk_unilist_set_text(list,list->focus_row,1,text[1]);
			gtk_unilist_set_text(list,list->focus_row,6,format_number(text[1]));
			//mainrefresh();
			updatestatusbar();
		}} else preview();
//		  if (!g_spawn_command_line_async(g_strdup_printf("%s %s",editor,escapefilename(text[0])),&error))
//				messageboxerror(error->message);
}}
void edit(){
	GError *error = NULL;
	gchar *text[8];
	GtkUniList *list=NULL;
	if (gtk_widget_is_focus(leftlist)) list = GTK_UNILIST(leftlist);
	if (gtk_widget_is_focus(rightlist)) list = GTK_UNILIST(rightlist);
	if (list != NULL){
		gtk_unilist_get_text(list,list->focus_row,0,&text[0]);
		gtk_unilist_get_text(list,list->focus_row,3,&text[3]);
		gtk_unilist_get_text(list,list->focus_row,6,&text[6]);
//		g_print("%s\n",gtk_entry_get_text(GTK_ENTRY(commandline)));
		chdir (gtk_frame_get_label(GTK_FRAME(commandlineframe)));
		if (text[3][0]!='d')
		  if (!g_spawn_command_line_async(g_strdup_printf("%s %s",editor,escapefilename(text[0])),&error))
				messageboxerror(error->message);
}}

void execute(gchar *filename){
	GError *error = NULL;
		chdir (gtk_frame_get_label(GTK_FRAME(commandlineframe)));
		if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(interminal))){
			if (!g_spawn_command_line_async(g_strdup_printf("%s '/bin/sh -c \"cd %s;%s;/bin/sh\"'",
				 		terminal,escapefilename((gchar *)gtk_frame_get_label(GTK_FRAME(commandlineframe))),filename),&error))
				messageboxerror(error->message);
		} else if (!g_spawn_command_line_async(filename,&error))
				messageboxerror(error->message);
}
gint gtk_unilist_set_focus(){
	switch (curfocus){
		case 0:		gtk_window_set_focus(GTK_WINDOW(mainwindow),leftlist);break;
		case 1:		gtk_window_set_focus(GTK_WINDOW(mainwindow),rightlist);break;
		case 2:		gtk_window_set_focus(GTK_WINDOW(mainwindow),commandline);break;
	}//return TRUE;
}
int commandline_lost_focus(GtkWidget *list, GdkEventKey *event, gpointer data){
	if (event->keyval == GDK_Up || event->keyval == GDK_KP_Up ||
		event->keyval == GDK_Down || event->keyval == GDK_KP_Down ||
		event->keyval == GDK_Tab){gtk_unilist_set_focus();return TRUE;}
	if (event->keyval == GDK_KP_Enter || event->keyval == GDK_Return){
	  if (event->state&GDK_CONTROL_MASK || event->state&GDK_MOD1_MASK){
			gchar *text[8];
		if (curfocus==0)gtk_unilist_get_text(GTK_UNILIST(leftlist),GTK_UNILIST(leftlist)->focus_row,0,&text[0]);
		else gtk_unilist_get_text(GTK_UNILIST(rightlist),GTK_UNILIST(rightlist)->focus_row,0,&text[0]);
			gint pos=GTK_ENTRY(commandline)->current_pos;text[0]=escapefilename(text[0]);
			gtk_signal_emit_by_name(GTK_OBJECT(commandline),"insert-at-cursor",text[0],NULL);
			gtk_window_set_focus (GTK_WINDOW(mainwindow), commandline);
			gtk_entry_set_position(GTK_ENTRY(commandline),pos+strlen(text[0]));
	  }else{
		gchar *command = (gchar *)gtk_entry_get_text(GTK_ENTRY(list));
		if (strlen(command)>0){execute(command);gtk_entry_set_text(GTK_ENTRY(list),"");}
		else gtk_unilist_set_focus();
		return TRUE;
	}}
	return FALSE;
}
void updatecommandlineframe(){
	if (gtk_widget_is_focus(leftlist)){curfocus=0;chdir(leftdirstr);}
	if (gtk_widget_is_focus(rightlist)){curfocus=1;chdir(rightdirstr);}
	gtk_frame_set_label(GTK_FRAME(commandlineframe),g_get_current_dir());
}
gchar * escapefilename(gchar *filename){
	gchar newfilename[256];
	gint cur=0,i;
	for (i=0; i<strlen(filename);i++){
		if (filename[i]==' ' || filename[i]=='\[' || filename[i]=='\]' || filename[i]=='\\'){
				newfilename[cur]='\\';cur++;}
		newfilename[cur]=filename[i];cur++;
	}newfilename[cur]=NULL;
	return g_strdup(newfilename);
}
void makelink(){
	GtkWidget *gtkframe;
	gchar *source,*destination,*label;
	if (curfocus==0) gtk_unilist_get_text(GTK_UNILIST(leftlist),GTK_UNILIST(leftlist)->focus_row,0,&source);
	else gtk_unilist_get_text(GTK_UNILIST(rightlist),GTK_UNILIST(rightlist)->focus_row,0,&source);
	GtkWidget *dialog = gtk_dialog_new_with_buttons ("Link",GTK_WINDOW(mainwindow), GTK_DIALOG_DESTROY_WITH_PARENT,GTK_STOCK_CANCEL,GTK_RESPONSE_REJECT,GTK_STOCK_OK,GTK_RESPONSE_ACCEPT,NULL);
	gtk_dialog_set_default_response(GTK_DIALOG(dialog),GTK_RESPONSE_ACCEPT);
	label=g_strdup_printf("Link %s to:",source);
	gtkframe = gtk_frame_new(label);gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), gtkframe, FALSE, TRUE, 0);
	GtkWidget *entry = gtk_entry_new();gtk_container_add(GTK_CONTAINER(gtkframe),entry);
	gtk_entry_set_activates_default(GTK_ENTRY(entry),TRUE);
	gtk_window_set_focus(GTK_WINDOW(dialog),entry);
	gtk_widget_show_all(dialog);
	if (gtk_dialog_run(GTK_DIALOG(dialog))==GTK_RESPONSE_ACCEPT){
		if (0!=link(escapefilename(source),escapefilename((gchar *)gtk_entry_get_text(GTK_ENTRY(entry)))))
				messageboxerror(strerror(errno));
		rereadsourceall();
	}
	gtk_widget_destroy(dialog);
	g_free(label);g_free(destination);
}
void makesymlink(){
	GtkWidget *gtkframe;
	gchar *source,*destination;
	if (curfocus==0) {gtk_unilist_get_text(GTK_UNILIST(leftlist),GTK_UNILIST(leftlist)->focus_row,0,&source);
		destination=g_strdup_printf("%s%s",rightdirstr,source);
		source=g_strdup_printf("%s%s",leftdirstr,source);
	}else{ gtk_unilist_get_text(GTK_UNILIST(rightlist),GTK_UNILIST(rightlist)->focus_row,0,&source);
		destination=g_strdup_printf("%s%s",leftdirstr,source);
		source=g_strdup_printf("%s%s",rightdirstr,source);
	}
	GtkWidget *dialog = gtk_dialog_new_with_buttons ("Link",GTK_WINDOW(mainwindow), GTK_DIALOG_DESTROY_WITH_PARENT,GTK_STOCK_CANCEL,GTK_RESPONSE_REJECT,GTK_STOCK_OK,GTK_RESPONSE_ACCEPT,NULL);
	gtk_dialog_set_default_response(GTK_DIALOG(dialog),GTK_RESPONSE_ACCEPT);
	gtkframe = gtk_frame_new("Existing filename (filename symlink will point to):");
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), gtkframe, FALSE, TRUE, 0);
	GtkWidget *entry1 = gtk_entry_new();gtk_entry_set_text(GTK_ENTRY(entry1),source);
	gtk_container_add(GTK_CONTAINER(gtkframe),entry1);
	gtkframe = gtk_frame_new("Symbolic link filename:");
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), gtkframe, FALSE, TRUE, 0);
	GtkWidget *entry2 = gtk_entry_new();gtk_entry_set_text(GTK_ENTRY(entry2),destination);
	gtk_container_add(GTK_CONTAINER(gtkframe),entry2);
	gtk_entry_set_activates_default(GTK_ENTRY(entry1),TRUE);
	gtk_entry_set_activates_default(GTK_ENTRY(entry2),TRUE);
	gtk_window_set_focus(GTK_WINDOW(dialog),entry1);
	gtk_widget_show_all(dialog);
	if (gtk_dialog_run(GTK_DIALOG(dialog))==GTK_RESPONSE_ACCEPT){
		if (0!=symlink( escapefilename((gchar *)gtk_entry_get_text(GTK_ENTRY(entry1))),
						escapefilename((gchar *)gtk_entry_get_text(GTK_ENTRY(entry2)))))
				messageboxerror(strerror(errno));
		rereadsourceall();
	}
	gtk_widget_destroy(dialog);
	g_free(source);g_free(destination);
}
void operation(gint op){
	GArray *filelist;
	gchar *text[8], *message="No files selected!", *type, *destination;
	GError *error = NULL;
	GtkUniList *list;gint count=0,cur;
	all=-1;
	filelist=g_array_new(TRUE, TRUE, 256);
	if (curfocus==0) {list=GTK_UNILIST(leftlist);destination=g_strdup(rightdirstr);}
	else {list=GTK_UNILIST(rightlist);destination=g_strdup(leftdirstr);}
	gtk_unilist_get_text(list,0,0,&text[0]);
	if (strcmp(text[0],"..")==0) gtk_unilist_unselect_row(list,0,0);
	for (gint row=0; row<list->rows;row++){
		if (gtk_unilist_row_is_selected(list,row)){count++;cur=row;
			gtk_unilist_get_text(list,row,0,&text[0]);
			g_array_append_val(filelist, *text[0]);
		}
	}
	if (count==0 || count==1){
		if (count==0){
				gtk_unilist_get_text(list,list->focus_row,0,&text[0]);
				gtk_unilist_get_text(list,list->focus_row,3,&text[3]);
		}else {	gtk_unilist_get_text(list,cur,0,&text[0]);
				gtk_unilist_get_text(list,cur,3,&text[3]);}
	 if (strcmp(text[0],"..")==0) messageboxinfo(message);
	 else{if (text[3][0]=='d') type="the directory";else type="the file";
		switch (op){
			case 0:
				message=g_strdup_printf("Do you really want to delete %s %s?",type,text[0]);
				if (messageboxyesno(message))removefile(text[0]);
				break;
			case 1:
				message=g_strdup_printf("Rename/Move %s %s to",type,text[0]);
				str=g_strconcat(destination,text[0],NULL);
				if (messageboxinput("Rename/Move",message)){
					if (0!=rename(text[0],str))
						messageboxerror(strerror(errno));
				}g_free(str);break;
			case 2:
				message=g_strdup_printf("Copy %s %s to",type,text[0]);
				str=destination;messageboxinputattr=TRUE;
				if (messageboxinput("Copy",message)){copycur=0;
					copyfile(text[0],str,TRUE,0,1);//g_print("CCCC\n");
//					if (copyfile(text[0],str,TRUE,0,1))
//						messageboxerror(strerror(errno));
					if (GTK_IS_WIDGET(dialog))gtk_widget_destroy(dialog);
					messageboxinputattr=FALSE;
				}break;
		}
		rereadsourceall();
		g_free(message);
	}}else{
		switch (op){
			case 0:
				message=g_strdup_printf("Do you really want to delete the %d selected files/directories?",count);
				if (messageboxyesno(message)){operationfiles(filelist,op);rereadsourceall();}
				break;
			case 1:
				message=g_strdup_printf("Move the %d selected files/directories to",count);str=destination;
				if (messageboxinput("Move",message)){
					if (g_file_test(str,G_FILE_TEST_IS_DIR)){operationfiles(filelist,op);rereadsourceall();}
					else messageboxerror(g_strdup_printf("Destination '%s' is not directory !!!",str));
				}
				break;
			case 2:
				message=g_strdup_printf("Copy the %d selected files/directories to",count);str=destination;messageboxinputattr=TRUE;
				if (messageboxinput("Copy",message)){
					if (g_file_test(str,G_FILE_TEST_IS_DIR)){operationfiles(filelist,op);rereadsourceall();}
					else messageboxerror(g_strdup_printf("Destination '%s' is not directory !!!",str));
					messageboxinputattr=FALSE;
				}break;
		}g_free(message);
	}
	g_array_free(filelist, TRUE);
	g_free(destination);
}
void deletefiles(){operation(0);}
void renamefiles(){operation(1);}
void copyfiles(){operation(2);}

void removeall(gchar *file){
	GDir *dir;GError *error;
	gchar *name;
	if (g_file_test(file,G_FILE_TEST_IS_DIR)){
		dir = g_dir_open(file,0,&error);
	  if (dir !=NULL){if (0!=chdir (file)){g_dir_close(dir);return;}
		name = (gchar *)g_dir_read_name(dir);
		while (name!=NULL){
			if (0!=remove(name))if (errno==ENOTEMPTY) removeall(name);
			name = (gchar *)g_dir_read_name(dir);
		}
		g_dir_close(dir);
	  } chdir ("..");remove(file);
}}
gint removefile(gchar *file){
	gint ret=TRUE, result;
	GtkWidget *dialog = gtk_dialog_new_with_buttons ("Delete",GTK_WINDOW(mainwindow), GTK_DIALOG_DESTROY_WITH_PARENT,GTK_STOCK_YES,GTK_RESPONSE_YES, GTK_STOCK_NO, GTK_RESPONSE_NO, "All",1,"None",2,GTK_STOCK_CANCEL,GTK_RESPONSE_CANCEL,NULL);
	GtkWidget *hbox = gtk_hbox_new(FALSE,0);gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), hbox, FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), gtk_image_new_from_stock(GTK_STOCK_DIALOG_QUESTION,GTK_ICON_SIZE_DIALOG), FALSE, TRUE, 10);
	GtkWidget *label=gtk_label_new(NULL);gtk_box_pack_start(GTK_BOX(hbox),label, FALSE, TRUE, 2);

	if (all!=FALSE || !g_file_test(file,G_FILE_TEST_IS_DIR)){
	  if (0!=remove(file)){
		if (errno==ENOTEMPTY){ 
			if (all==TRUE) result=GTK_RESPONSE_YES;
			else{
				gtk_label_set_text(GTK_LABEL(label),
					g_strdup_printf("%s: %s.\nDo you want to delete it with all its files and subdirectories?",
						file,strerror(errno)));
				gtk_widget_show_all(dialog);result=gtk_dialog_run(GTK_DIALOG(dialog));
			}
			switch (result){
				case GTK_RESPONSE_YES:removeall(file); break;
				case GTK_RESPONSE_NO: break;
				case 1:all=TRUE;removeall(file); break;
				case 2:all=FALSE; break;
				default: ret=FALSE;break;
		}}else { messageboxerror(strerror(errno)); ret=FALSE;}
	}} 
	gtk_widget_destroy(dialog);
	return ret;
}
void operationfiles (GArray *list, gint op){
	gchar *message, *file, *destination;
	gint res, begin=TRUE;gfloat size;
	struct stat stat_src;

	if (op==1){
		if (str[strlen(str)-1]!='/') 
			{destination=g_strconcat(str,"/",NULL);g_free(str);str=destination;}
	}
	if (op==2){
		for (gint i=0; i<list->len;i++){
		  file=&g_array_index(list,gchar,i*256);
		  if (0==stat(file,&stat_src)) size+=stat_src.st_size;
		}copycur=0;copysize=size;
	}
	for (gint i=0; i<list->len;i++){
		file=&g_array_index(list,gchar,i*256);
		switch (op){
			case 0:if (!removefile(file)) return;break;
			case 1:	destination=g_strconcat(str,file,NULL);
					res=rename(file,destination);g_free(destination);
					if (res) {messageboxerror(strerror(errno));return;}
				break;
			case 2:	destination=str;res=copyfile(file,destination,begin,i,list->len);begin=FALSE;
				if (res) return;
				break;
		}
	} if (op==2 && begin==FALSE) gtk_widget_destroy(dialog);
}
gint copycancel (){abortcopy=TRUE;return TRUE;}
gint copyfile(gchar *file, gchar *destination, gint begin, gint cur, gint count){
	GtkWidget *gtkframe;
	gchar *from,*to,*label,*labelfrom,*labelto,*progresscounttext=NULL;
	gint width,height,width2,height2;
	from = g_strconcat(get_current_dir_name(),"/",file,NULL);
	to = g_strdup(destination);
	
//	g_print("%s:%s\n",file,destination);
	gint percent=(gfloat)cur/count*100;
	progresscounttext=g_strdup_printf("%d \% (%d\/%d)",percent,cur,count);
if (begin==TRUE){abortcopy=FALSE;
	if (g_file_test(destination,G_FILE_TEST_EXISTS)){
		if (g_file_test(destination,G_FILE_TEST_IS_DIR)){
			if (strlen(destination)<2 || destination[strlen(destination)-1]=='/')
				{g_free(to);to = g_strconcat(destination,file,NULL);}
			else {g_free(to);to = g_strconcat(destination,"/",file,NULL);}
		}else return FALSE;
	}
	gtk_window_get_size(GTK_WINDOW(mainwindow),&width,&height);
	dialog = gtk_dialog_new_with_buttons ("Copy",GTK_WINDOW(mainwindow), GTK_DIALOG_DESTROY_WITH_PARENT,GTK_STOCK_CANCEL,GTK_RESPONSE_CANCEL,NULL);
	labelfrom=g_strdup_printf("FROM: %s",from);fromlabel = gtk_label_new(labelfrom);
	gtk_misc_set_alignment(GTK_MISC(fromlabel),0,0.5);
	labelto=g_strdup_printf("TO: %s",to);tolabel = gtk_label_new(labelto);
	gtk_misc_set_alignment(GTK_MISC(tolabel),0,0.5);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), fromlabel, FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), tolabel, FALSE, TRUE, 0);
	if (count==1) copysize=0;
//if (count>1){
	gtkframe = gtk_frame_new("Total Bytes:");
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), gtkframe, FALSE, TRUE, 0);
	progressbytes = gtk_progress_bar_new();
	gtk_container_add(GTK_CONTAINER(gtkframe),progressbytes);
	gtk_progress_set_show_text(GTK_PROGRESS(progressbytes),TRUE);
//}else copysize=-1;
	gtkframe = gtk_frame_new("Current:");
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), gtkframe, FALSE, TRUE, 0);
	progress = gtk_progress_bar_new();
	gtk_container_add(GTK_CONTAINER(gtkframe),progress);
	gtk_progress_set_show_text(GTK_PROGRESS(progress),TRUE);
	gtkframe = gtk_frame_new("Total Files Count:");
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), gtkframe, FALSE, TRUE, 0);
	progresscount = gtk_progress_bar_new();
	gtk_container_add(GTK_CONTAINER(gtkframe),progresscount);
	gtk_progress_set_show_text(GTK_PROGRESS(progresscount),TRUE);
	gtk_progress_bar_update(GTK_PROGRESS_BAR(progresscount),(gfloat)cur/count);
	gtk_progress_bar_set_text(GTK_PROGRESS_BAR(progresscount),progresscounttext);
	
	g_signal_connect(GTK_OBJECT(dialog),"response",G_CALLBACK(copycancel),GTK_OBJECT(dialog));
	g_signal_connect(GTK_OBJECT(dialog),"delete-event",G_CALLBACK(copycancel),GTK_OBJECT(dialog));
	gtk_window_get_size(GTK_WINDOW(dialog),&width2,&height2);
	gtk_window_resize(GTK_WINDOW(dialog),width*0.55,height2);
	gtk_widget_show_all(dialog);gtk_window_set_transient_for(GTK_WINDOW(dialog),GTK_WINDOW(mainwindow));
	gtk_grab_add(dialog);
	while (gtk_events_pending()) gtk_main_iteration();
}else {
  if (count>1)
	if (g_file_test(destination,G_FILE_TEST_EXISTS)){
		if (g_file_test(destination,G_FILE_TEST_IS_DIR)){
			if (strlen(destination)<2 || destination[strlen(destination)-1]=='/')
				{g_free(to);to = g_strconcat(destination,file,NULL);}
			else 
				{g_free(to);to = g_strconcat(destination,"/",file,NULL);}
		} else {return FALSE;}
	}
	labelfrom=g_strdup_printf("FROM: %s",from);gtk_label_set_text(GTK_LABEL(fromlabel),labelfrom);
	labelto=g_strdup_printf("TO: %s",to);gtk_label_set_text(GTK_LABEL(tolabel),labelto);
	gtk_progress_bar_update(GTK_PROGRESS_BAR(progresscount),(gfloat)cur/count);
	gtk_progress_bar_set_text(GTK_PROGRESS_BAR(progresscount),progresscounttext);
	}

	gint res=copy(from,to);//	g_print("111:%s:%s\n",from,to);

	g_free(from);g_free(to);g_free(labelfrom);g_free(labelto);g_free(progresscounttext);
	from=to=labelfrom=labelto=progresscounttext=NULL;
	//g_print("111222\n");
	if (res==TRUE) return 0;
	
	if (GTK_IS_WIDGET(dialog)){gtk_widget_destroy(dialog);dialog=NULL;}
	return -1;
}
gint copy(gchar *source, gchar *destination){
	GDir *dir;GError *error;
	struct stat stat_src, stat_dst;
	GtkWidget *question;
	time_t starttime, curtime;struct timeval tvp[2];
	gchar *buf=NULL,speed[10],*name,*namedestination=NULL;
	guint buf_size; ssize_t count,total=0;
	gint src, dst, elapsedtime, percenthuman, res;
	gfloat percent;
	starttime = time (NULL);
	if (g_file_test(source,G_FILE_TEST_IS_SYMLINK)) {
		buf=(gchar *)g_malloc(1024);
		res=readlink(source,buf,1024);
		if (res<=0){g_free(buf);return FALSE;}
		buf[res]=0;//g_print("%s=%s=%s\n",get_current_dir_name(),buf,destination);
		res=symlink(buf,destination);
		g_free(buf);if(res==0)return TRUE;
		return FALSE;
	}
//	g_print ("s:%s\nd:%s\n",source,destination);
	if (g_file_test(source,G_FILE_TEST_IS_DIR)){
		if (!g_file_test(destination,G_FILE_TEST_EXISTS)){
			if (0!=mkdir(destination,S_IRWXU|S_IRGRP|S_IXGRP|S_IROTH|S_IXOTH)) return FALSE;
		} else if (!g_file_test(destination,G_FILE_TEST_IS_DIR)) return FALSE;
		dir = g_dir_open(source,0,&error);
	  if (dir!=NULL){if (0!=chdir (source)){g_dir_close(dir);return FALSE;}
		name = (gchar *)g_dir_read_name(dir);
		while (name!=NULL){namedestination=g_strconcat(destination,"/",name,NULL);
			res=copyfile(name,namedestination,FALSE,0,1);g_free(namedestination);if (res) return FALSE;
			name = (gchar *)g_dir_read_name(dir);
		}
		g_dir_close(dir);
	  } chdir ("..");return TRUE;
	}
	if (0!=stat(source,&stat_src)){messageboxerror("Can not state source...");return FALSE;}
	if (g_file_test(source,G_FILE_TEST_IS_REGULAR)){
		buf_size=stat_src.st_blksize;buf=(gchar *)g_malloc(buf_size);
		src=open(source,O_RDONLY);dst=open(destination,O_WRONLY|O_CREAT|O_EXCL|O_TRUNC);
		if (dst==-1){
			if(0==stat(destination,&stat_dst)){
				if (all==TRUE)res=2;if (all==FALSE)res=3;
			  if (all==-1){res=-1;
				question=gtk_dialog_new_with_buttons("Copy",GTK_WINDOW(mainwindow), GTK_DIALOG_DESTROY_WITH_PARENT,GTK_STOCK_YES,GTK_RESPONSE_YES, GTK_STOCK_NO, GTK_RESPONSE_NO, "All",1,"None",2,"Append",3,"Resume",4,GTK_STOCK_CANCEL,GTK_RESPONSE_CANCEL,NULL);
				GtkWidget *hbox = gtk_hbox_new(FALSE,0);gtk_box_pack_start(GTK_BOX(GTK_DIALOG(question)->vbox), hbox, FALSE, TRUE, 0);
				gtk_box_pack_start(GTK_BOX(hbox), gtk_image_new_from_stock(GTK_STOCK_DIALOG_QUESTION,GTK_ICON_SIZE_DIALOG), FALSE, TRUE, 10);
				GtkWidget *label=gtk_label_new(NULL);gtk_box_pack_start(GTK_BOX(hbox),label, FALSE, TRUE, 2);
				gtk_label_set_text(GTK_LABEL(label),
					g_strdup_printf("%s: %s.\nDo you want to owerwrite it?",
						destination,strerror(errno)));
				gtk_widget_show_all(question);res=gtk_dialog_run(GTK_DIALOG(question));
				gtk_widget_destroy(question);
			  }
			  switch (res){
				case GTK_RESPONSE_YES:dst=open(destination,O_WRONLY|O_CREAT|O_TRUNC); break;
				case GTK_RESPONSE_NO:return TRUE; break;
				case 1:all=TRUE;dst=open(destination,O_WRONLY|O_CREAT|O_TRUNC); break;
				case 2:all=FALSE;return TRUE; break;
				case 3:dst=open(destination,O_WRONLY|O_APPEND); break;
				case 4:if (stat_src.st_size<stat_dst.st_size){messageboxerror("Source < Destination...");return FALSE;}
					lseek(src,stat_dst.st_size,SEEK_CUR);total=copycur+=stat_dst.st_size;
					dst=open(destination,O_WRONLY|O_APPEND); break;
				default: return FALSE;break;
			  }}else{messageboxerror("Cann't state destination...");return FALSE;}
		}
		fchmod(dst,stat_src.st_mode);
		if (messageboxinputattr==TRUE)fchown(dst,stat_src.st_uid,stat_src.st_uid);
		if (src!=-1 && dst!=-1){
			count=read(src,buf,buf_size);total+=count;copycur+=count;
			while (count>0){curtime=time(NULL);
				if (count!=write(dst,buf,count)){g_free(buf);close(src);close(dst);
					messageboxerror("Error in writing...");return FALSE;
				}
				if ((curtime-starttime)!=elapsedtime){elapsedtime=curtime-starttime;
//					if (copysize>-1){
					if (copysize==0){
						g_free(progressbytestext);
						progressbytestext=g_strdup_printf("%d \% (%s)",
							0,format_size(copycur));
						gtk_progress_bar_set_text(GTK_PROGRESS_BAR(progressbytes),progressbytestext);
					}else{
						percent=(gfloat)copycur/copysize;percenthuman=percent*100;
						if (percent>1) {percent=1;percenthuman=100;}
						g_free(progressbytestext);
						progressbytestext=g_strdup_printf("%d \% (%s\/%s)",
							percenthuman,format_size(copycur),format_size(copysize));
						gtk_progress_bar_update(GTK_PROGRESS_BAR(progressbytes),percent);
						gtk_progress_bar_set_text(GTK_PROGRESS_BAR(progressbytes),progressbytestext);
					}
					percent=(gfloat)total/stat_src.st_size;percenthuman=percent*100;
					curtime=time(NULL);g_free(progresstext);
					progresstext=g_strdup_printf("%d \% (%s\/%s) %s\/s",
						percenthuman,format_size((gfloat)total),format_size((gfloat)stat_src.st_size),
						format_size((gfloat)total/elapsedtime));
					gtk_progress_bar_update(GTK_PROGRESS_BAR(progress),percent);
					gtk_progress_bar_set_text(GTK_PROGRESS_BAR(progress),progresstext);
					while (gtk_events_pending()) gtk_main_iteration();
					if (abortcopy) {
						if (messageboxyesno("Do you want abort?")){
							close(src);close(dst);
							if (total==0)unlink(destination);
							else{res=messageboxyesno("Do you want keep it?\n(No for delete...)");
								if (res==FALSE)unlink(destination);
							}
							return FALSE;}
						else abortcopy=FALSE;
					}
				}
				count=read(src,buf,buf_size);total+=count;copycur+=count;
			}
			close(src);close(dst);
			if (messageboxinputattr==TRUE){
				tvp[0].tv_sec=stat_src.st_atime;tvp[0].tv_usec=0;
				tvp[1].tv_sec=stat_src.st_mtime;tvp[1].tv_usec=0;
				utimes(destination,tvp);
			}
		}else{g_free(buf);close(src);close(dst);unlink(destination);messageboxerror("Error in copying...");return FALSE;}
		g_free(buf);
	}
	return TRUE;
}
VFS_mime* checkregex(gchar *name){
	VFS_mime *mimedata, *data;
	regex_t compiled;
	gint res, i, found;
	i=0;found=FALSE;
	while (i<g_list_length(mimearr) && found==FALSE){
		data=(VFS_mime*)g_list_nth_data(mimearr,i);
		res=regcomp(&compiled,(gchar*)data->regex,NULL);
			//if (res!=0){ printf("Error compiling %s\n",name);return;}
		if (0==regexec(&compiled,name,0,NULL,0)) found=TRUE;
			//if (res==0) printf("Ok\n");
		regfree(&compiled);
		i++;
	}
	if (found)return data;
	return NULL;
}

void ftpconnect(){str=NULL;
	struct hostent *hostinfo;
	struct sockaddr_in servername;
	uint16_t port=21;
	int sock, nbytes;
	gchar buffer[1500];
	if (messageboxinput("FTP Connect","Input ftp address:")){
		hostinfo = gethostbyname(str);
		if (hostinfo==NULL){messageboxerror((gchar *)hstrerror(h_errno));return;}
		servername.sin_family = AF_INET;
		servername.sin_port = g_htons (port);
		servername.sin_addr = *(struct in_addr *) hostinfo->h_addr;
		sock = socket (PF_INET, SOCK_STREAM, 0);
		if (sock<0) {messageboxerror((gchar *)hstrerror(h_errno));return;}
		if (0>connect(sock,(struct sockaddr *)&servername, sizeof (servername)))
			{messageboxerror(strerror(errno));return;}
		nbytes = read (sock,buffer,1492);
		if (nbytes==-1){messageboxerror(strerror(errno));return;}
		buffer[nbytes]=0;
		g_print("%s\n",buffer);
//		messageboxinfo(host->h_name);
		preview();
	}}
