#include "../config.h"
#include <gtk/gtk.h>
#include <string.h>
#include <unistd.h>
#include <math.h>
#include <locale.h>

//#ifndef __MRC_MAIN__
//#define __MRC_MAIN__
#include "../include/main.h"
#include "../include/gtkunilist.h"
//#endif
//#include "../include/support.h"

gchar buffer[256];

void readdir (gchar *dir, GArray *dirlist, gint hidden, gint backup){
	GDir *dirhandle;
	gchar *errstr = "Error\n";
	gchar *name;
	GError *error;
	
	error = g_error_new(1,0,errstr);
	dirhandle = g_dir_open(dir,0, &error);

	g_array_free(dirlist, TRUE);
	dirlist=g_array_new(TRUE, TRUE, 256);
	g_array_append_val(dirlist, *dir);
	(const gchar *)name = g_dir_read_name (dirhandle);
	while (name != NULL){
		if (hidden!=FALSE or name[0]!='.')
			if (backup!=FALSE or name[strlen(name)-1]!='~')
					g_array_append_val(dirlist, *name);
//		else g_print ("Removed:%s\n",name);
		(const gchar *)name = g_dir_read_name (dirhandle);
	}//test = &g_array_index(dirlist,gchar,256*2);g_print ("Arr :%s = %d\n",test,strlen(test));
	g_dir_close(dirhandle);g_free(error);
}

void showdir(GArray *dirarr,GtkWidget *dirlist, gchar *defaultfile, gint showicons){
	int width = GTK_UNILIST(dirlist)->row_height, height =GTK_UNILIST(dirlist)->row_height;
	GdkPixbuf *pixbuf,*dpixbuf,*rpixbuf,*bpixbuf,*cpixbuf,*spixbuf,*epixbuf;
	static GdkPixmap *icon=NULL,*dicon,*ricon,*bicon,*cicon,*sicon,*eicon; 
	static GdkBitmap *bitmap,*dbitmap,*rbitmap,*bbitmap,*cbitmap,*sbitmap,*ebitmap;
	pixbuf = gdk_pixbuf_new_from_file(geticon("i-directory.png"),NULL);
	if (pixbuf!=NULL){dpixbuf = gdk_pixbuf_scale_simple(pixbuf,height,width,GDK_INTERP_BILINEAR);
		gdk_pixbuf_render_pixmap_and_mask(dpixbuf,&dicon,&dbitmap,192);g_free(pixbuf);}
	pixbuf = gdk_pixbuf_new_from_file(geticon("i-regular.png"),NULL);
	if (pixbuf!=NULL){rpixbuf = gdk_pixbuf_scale_simple(pixbuf,height,width,GDK_INTERP_BILINEAR);
		gdk_pixbuf_render_pixmap_and_mask(rpixbuf,&ricon,&rbitmap,192);g_free(pixbuf);}
	pixbuf = gdk_pixbuf_new_from_file(geticon("i-blockdev.png"),NULL);
	if (pixbuf!=NULL){bpixbuf = gdk_pixbuf_scale_simple(pixbuf,height,width,GDK_INTERP_BILINEAR);
		gdk_pixbuf_render_pixmap_and_mask(bpixbuf,&bicon,&bbitmap,192);g_free(pixbuf);}
	pixbuf = gdk_pixbuf_new_from_file(geticon("i-chardev.png"),NULL);
	if (pixbuf!=NULL){cpixbuf = gdk_pixbuf_scale_simple(pixbuf,height,width,GDK_INTERP_BILINEAR);
		gdk_pixbuf_render_pixmap_and_mask(cpixbuf,&cicon,&cbitmap,192);g_free(pixbuf);}
	pixbuf = gdk_pixbuf_new_from_file(geticon("i-symlink.png"),NULL);
	if (pixbuf!=NULL){spixbuf = gdk_pixbuf_scale_simple(pixbuf,height,width,GDK_INTERP_BILINEAR);
		gdk_pixbuf_render_pixmap_and_mask(spixbuf,&sicon,&sbitmap,192);g_free(pixbuf);}
	pixbuf = gdk_pixbuf_new_from_file(geticon("i-executable.png"),NULL);
	if (pixbuf!=NULL){epixbuf = gdk_pixbuf_scale_simple(pixbuf,height,width,GDK_INTERP_BILINEAR);
		gdk_pixbuf_render_pixmap_and_mask(epixbuf,&eicon,&ebitmap,192);g_free(pixbuf);}

	VFS_mime *mimedata;gchar *iconname;
	
	gchar *d="d",*r="r",*b="b",*c="c", *s="s";
	gchar *file, *name[9]={"","","","d","","","","",""};
	gchar *dir=&g_array_index(dirarr,gchar,0);
	struct stat buf;
	gint j=1, cur=GTK_UNILIST(dirlist)->focus_row;
	
	gtk_unilist_freeze ((GtkUniList *)dirlist);
	gtk_unilist_clear((GtkUniList *)dirlist);
	
	for (guint i=1; i<dirarr->len; i++){
		file=&g_array_index(dirarr,gchar,256*i);name[5]="";
		
		name[4]=name[0]=file;
		if (0==stat(file,&buf)){
			if (g_file_test(name[0],G_FILE_TEST_IS_SYMLINK)){
				name[1]=g_strdup_printf("%d",readlink(file,buffer,256));
				name[6]=g_strdup_printf("-->%s",format_number(name[1]));
			}else {
				name[1]=g_strdup_printf("%d",buf.st_size);
				name[6]=format_number(name[1]);
			}
			name[2]=g_strdup_printf("%d",buf.st_mtime);
			name[7]=format_time(buf.st_mtime);
			name[8]=format_atr(buf.st_mode);
		}else name[6]="";
		  name[3]="";icon = NULL;
		  if (0==stat(file,&buf)){
			if (S_ISREG(buf.st_mode)) {name[3]=r;icon = ricon, bitmap = rbitmap;}
			if (S_ISBLK(buf.st_mode)) {name[3]=b;icon = bicon, bitmap = bbitmap;}
			if (S_ISCHR(buf.st_mode)) {name[3]=c;icon = cicon, bitmap = cbitmap;}
			if (g_file_test(name[0],G_FILE_TEST_IS_EXECUTABLE)){icon = eicon, bitmap = ebitmap;}
			if (g_file_test(name[0],G_FILE_TEST_IS_DIR)){name[3]=d;name[6]="<DIR>";icon = dicon, bitmap = dbitmap;}
			if (g_file_test(name[0],G_FILE_TEST_IS_SYMLINK)){icon = sicon, bitmap = sbitmap;
			//if (name[3]!=d) name[6]=g_strdup_printf("-->");
		  }//name[6]="->";}
//			if (S_ISDIR(buf.st_mode)) {name[3]=d;name[6]="<DIR>";icon = dicon, bitmap = dbitmap;}
//			if (S_ISLNK(buf.st_mode)) {name[3]=d;icon = sicon, bitmap = sbitmap;}
			if (S_ISREG(buf.st_mode) && showicons==0) {
				mimedata=checkregex(name[0]);
				if (mimedata!=NULL){
				  if (mimedata->icon!=NULL){//g_print("1:%s:%s\n",name[0],mimedata->icon);
					pixbuf = gdk_pixbuf_new_from_file(geticon((gchar *)mimedata->icon),NULL);
					if (pixbuf!=NULL){pixbuf = gdk_pixbuf_scale_simple(pixbuf,height,width,GDK_INTERP_BILINEAR);
						gdk_pixbuf_render_pixmap_and_mask(pixbuf,&icon,&bitmap,192);}
//					else {g_print("nerasta\n");}
			}}}
			}
		gtk_unilist_prepend ((GtkUniList *)dirlist, name);
		if (icon!=NULL && showicons!=2){
			gtk_unilist_set_pixtext(GTK_UNILIST(dirlist),0,4,name[4],2,icon, bitmap);
	}
	}
	gtk_unilist_sort((GtkUniList *)dirlist);
	if (strcmp(dir,"/") != 0){j=0;name[4]=name[0]="..";name[3]=d;name[6]="<DIR>";
		if (0==stat("..",&buf)){
			name[7]=name[2]=format_time(buf.st_mtime);
			name[8]=format_atr(buf.st_mode);
		}
		gtk_unilist_prepend ((GtkUniList *)dirlist, name);
	}
	if (strcmp(dir,"/") == 0 and strcmp(defaultfile,"..")==0)GTK_UNILIST(dirlist)->focus_row=0;
	else{ gint found=FALSE;
	  for (guint i=0; i<GTK_UNILIST(dirlist)->rows; i++){
		gtk_unilist_get_text(GTK_UNILIST(dirlist),i,0,&file);
		if (strcmp(defaultfile,file)==0){GTK_UNILIST(dirlist)->focus_row=i;found=TRUE;}
	  } if (found==FALSE && cur<GTK_UNILIST(dirlist)->rows)GTK_UNILIST(dirlist)->focus_row=cur;
	}
	gint rowsvisible=GTK_UNILIST(dirlist)->unilist_window_height/height-3;
	gfloat valign = 0.5;
	if (GTK_UNILIST(dirlist)->focus_row<rowsvisible) valign=1;
	if (GTK_UNILIST(dirlist)->focus_row==GTK_UNILIST(dirlist)->rows-1) valign=0;
	gtk_unilist_thaw ((GtkUniList *)dirlist);
	gtk_unilist_moveto(GTK_UNILIST(dirlist),GTK_UNILIST(dirlist)->focus_row,0,valign,0);
}

gchar * godir(gchar *dir,GArray *dirarr, GtkWidget *dirlist, gint hidden, gint backup, gchar *defaultfile, gint showicons){
	gchar *dirparent="..",*temp1=NULL,*temp2=NULL;
	if (defaultfile!=NULL)dirparent=g_strdup(defaultfile);

	gtk_window_set_focus (GTK_WINDOW(dirlist->parent->parent->parent->parent->parent), dirlist);
	gchar *newdir = g_strdup(dir);//;g_print("%s\n", get_current_dir_name());
	if (strcmp(basename(dir),"..")==0){temp1=newdir;
		newdir=g_strndup(newdir,strlen(newdir)-3);
		if (defaultfile==NULL)dirparent=basename(newdir);
		if (strlen(newdir) != 1){temp2=newdir;newdir=g_strndup(newdir,strlen(newdir)-strlen(basename(newdir)));
			if (strlen(newdir)==0){newdir="/";dirparent="..";}}
	} else if (strcmp(g_strndup(dir+strlen(dir)-1,1),"/")!=0){g_free(newdir);newdir = g_strconcat(dir,"/",NULL);		}
	chdir (newdir);
	readdir (newdir, dirarr, hidden, backup);
	showdir(dirarr, dirlist, dirparent, showicons);
	g_free(temp1);g_free(temp2);
	return newdir;
}

gchar * format_time(time_t time_src){
	static gchar str[30];
	time_t time_cur;
	time_cur = time(&time_cur);
	gint t1,t2;

	struct tm *timecur=localtime(&time_cur);
	strftime(str,sizeof str,"%Y%m%d",timecur);t2=atoi(str);
	struct tm *timesrc=localtime(&time_src);
	strftime(str,sizeof str,"%Y%m%d",timesrc);t1=atoi(str);

	if (t1>t2-10000)	strftime(str,sizeof str,"%b %d %H:%M",timesrc);
	else strftime(str,sizeof str,"%b %d %Y",timesrc);
	return str;
}
gchar * format_atr(mode_t mode_src){
	mode_t mode = mode_src;
	static gchar str[10]="rwxrwxrwx";
	
	for (int i=8;i>7;i-=3){
		if (mode>>1<<1!=mode)str[i]='x';else str[i]='-';mode>>=1;
		if (mode>>1<<1!=mode)str[i-1]='w';else str[i-1]='-';mode>>=1;
		if (mode>>1<<1!=mode)str[i-2]='r';else str[i-2]='-';mode>>=2;
	}
	return str;
}
#define KB 1024
#define MB 1024*KB
#define GB 1024*MB

gchar * format_size(gfloat num){
	if (num > GB) return g_strdup_printf("%0.2f GB",round(num/(KB*KB*KB)*100)/100);
	if (num > MB) return g_strdup_printf("%0.2f MB",round(num/(KB*KB)*100)/100);
	if (num > KB) return g_strdup_printf("%0.1f KB",round(num/KB*10)/10);
	return g_strdup_printf("%0.0f",num);;
}
gchar * format_number(gchar *size){
static gchar buffer[30];
	struct lconv * loc = localeconv();
	gint len=strlen(size);
	gint cur=0;
	for (gint i=0;i<strlen(size);i++){
		if ((len-i)/3*3==(len-i) && (len-i)/3*3!=len){buffer[cur]=loc->thousands_sep[0];cur++;}
		buffer[cur]=size[i];cur++;
	}buffer[cur]=NULL;
	return g_strdup(buffer);
}
gfloat calcdirsize(gchar *curdir){
	gfloat cursize=0;
	gint hidden=true,backup=true;
	GArray *dirarr;
	gchar *filename,*file,*dir;
	struct stat buf;
	
	dirarr=g_array_new(FALSE, FALSE, 0);
	readdir (curdir, dirarr, hidden, backup);
	dir=&g_array_index(dirarr,gchar,0);
//	g_print("%d\n",dirarr->len);
	for (guint i=1; i<dirarr->len; i++){
		filename=&g_array_index(dirarr,gchar,256*i);
		file=g_strdup_printf("%s/%s",curdir,filename);
		if (0==stat(file,&buf)){
//		  if (!(g_file_test(file,G_FILE_TEST_IS_SYMLINK)&&g_file_test(file,G_FILE_TEST_IS_DIR))){
			if (g_file_test(file,G_FILE_TEST_IS_DIR)) cursize+=calcdirsize(file);
//			else cursize+=(gfloat)readlink(file,buffer,256);
//			else 
			if (g_file_test(file,G_FILE_TEST_IS_SYMLINK))
				cursize+=(gfloat)readlink(file,buffer,256);
//				g_print("%s -> %d\n",file,readlink(file,buffer,256));
			else	cursize+=(gfloat)buf.st_size;
//		  } else cursize+=(gfloat)readlink(file,buffer,256);
		}g_free(file);
	}
	g_array_free(dirarr, TRUE);
//	g_print("%s -> %f\n",curdir,cursize);
	return cursize;
}
